#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Features._ChunkedOutput import _ChunkedOutput

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'ChunkedOutput.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ChunkedOutput(_ChunkedOutput):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(ChunkedOutput, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: Chunked Output at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''Chunked Output''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def defines(self, **KWS):



        ## CHEETAH: generated from @def defines at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(ChunkedOutput, self).defines()
        if _v is not None: write(_filter(_v))
        # 
        write('''
#define _CHUNK_SIZE ((long)''')
        _v = VFFSL(SL,"chunkSize",True) # '$chunkSize' on line 34, col 28
        if _v is not None: write(_filter(_v, rawExpr='$chunkSize')) # from line 34, col 28.
        write(''')
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def preAllocation(self, dict, **KWS):



        ## CHEETAH: generated from @def preAllocation($dict) at line 38, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        for mg in VFFSL(SL,"momentGroups",True): # generated from line 40, col 3
            propDimRep = mg.propDimRep
            if not propDimRep: # generated from line 42, col 5
                continue
            _v = VFFSL(SL,"propDimRep.localLattice",True) # '${propDimRep.localLattice}' on line 45, col 1
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localLattice}')) # from line 45, col 1.
            write(''' = ''')
            _v = VFFSL(SL,"propDimRep.globalLattice",True) # '${propDimRep.globalLattice}' on line 45, col 30
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.globalLattice}')) # from line 45, col 30.
            write(''';
if (''')
            _v = VFN(VFFSL(SL,"mg.processedVector",True),"sizeInBasis",False)(mg.codeBlocks['sampling'].basis) # "${mg.processedVector.sizeInBasis(mg.codeBlocks['sampling'].basis)}" on line 46, col 5
            if _v is not None: write(_filter(_v, rawExpr="${mg.processedVector.sizeInBasis(mg.codeBlocks['sampling'].basis)}")) # from line 46, col 5.
            write(''')
  ''')
            _v = VFFSL(SL,"propDimRep.localLattice",True) # '${propDimRep.localLattice}' on line 47, col 3
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localLattice}')) # from line 47, col 3.
            write(''' = MIN((_CHUNK_SIZE-1) / (''')
            _v = VFN(VFFSL(SL,"mg.processedVector",True),"sizeInBasis",False)(mg.codeBlocks['sampling'].basis) # "${mg.processedVector.sizeInBasis(mg.codeBlocks['sampling'].basis)}" on line 47, col 55
            if _v is not None: write(_filter(_v, rawExpr="${mg.processedVector.sizeInBasis(mg.codeBlocks['sampling'].basis)}")) # from line 47, col 55.
            write(''' / ''')
            _v = VFFSL(SL,"propDimRep.globalLattice",True) # '${propDimRep.globalLattice}' on line 47, col 124
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.globalLattice}')) # from line 47, col 124.
            write(''' * sizeof(''')
            _v = VFFSL(SL,"mg.processedVector.type",True) # '${mg.processedVector.type}' on line 47, col 161
            if _v is not None: write(_filter(_v, rawExpr='${mg.processedVector.type}')) # from line 47, col 161.
            write(''')) + 1, ''')
            _v = VFFSL(SL,"propDimRep.globalLattice",True) # '${propDimRep.globalLattice}' on line 47, col 195
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.globalLattice}')) # from line 47, col 195.
            write(''');
''')
            _v = VFFSL(SL,"insertCodeForFeatures",False)('findMax', ['Driver'], {'variable': '&' + propDimRep.localLattice, 'count': 1, 'op': 'min', 'type': 'long'}) # "${insertCodeForFeatures('findMax', ['Driver'], {'variable': '&' + propDimRep.localLattice, 'count': 1, 'op': 'min', 'type': 'long'}), autoIndent=True}" on line 48, col 1
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${insertCodeForFeatures('findMax', ['Driver'], {'variable': '&' + propDimRep.localLattice, 'count': 1, 'op': 'min', 'type': 'long'}), autoIndent=True}")) # from line 48, col 1.
            write('''// Now find the minimum and broadcast it.
''')
        #  Initialise output files
        outputFeature = VFFSL(SL,"features",True)['Output']
        _v = VFN(VFFSL(SL,"outputFeature.outputFormat",True),"writeOutSetup",False)(''.join(['("',str(VFFSL(SL,"outputFeature.filename",True)),'" + gsArgsAndValues).c_str()']), outputFeature) # '${outputFeature.outputFormat.writeOutSetup(c\'("${outputFeature.filename}" + gsArgsAndValues).c_str()\', outputFeature)}' on line 53, col 1
        if _v is not None: write(_filter(_v, rawExpr='${outputFeature.outputFormat.writeOutSetup(c\'("${outputFeature.filename}" + gsArgsAndValues).c_str()\', outputFeature)}')) # from line 53, col 1.
        _v = VFFSL(SL,"outputFeature.outputFormat.writeOutTearDown",True) # '${outputFeature.outputFormat.writeOutTearDown}' on line 54, col 1
        if _v is not None: write(_filter(_v, rawExpr='${outputFeature.outputFormat.writeOutTearDown}')) # from line 54, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def sampleFunctionEnd(self, dict, **KWS):



        ## CHEETAH: generated from @def sampleFunctionEnd($dict) at line 58, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        mg = dict['caller']
        propDimRep = mg.propDimRep
        # 
        if not propDimRep: # generated from line 63, col 3
            return
        write('''if (''')
        _v = VFFSL(SL,"propDimRep.index",True) # '${propDimRep.index}' on line 66, col 5
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.index}')) # from line 66, col 5.
        write(''' == ''')
        _v = VFFSL(SL,"propDimRep.localLattice",True) # '${propDimRep.localLattice}' on line 66, col 28
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localLattice}')) # from line 66, col 28.
        write('''
    && (''')
        _v = VFFSL(SL,"propDimRep.index",True) # '${propDimRep.index}' on line 67, col 9
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.index}')) # from line 67, col 9.
        write(''' + ''')
        _v = VFFSL(SL,"propDimRep.localOffset",True) # '${propDimRep.localOffset}' on line 67, col 31
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localOffset}')) # from line 67, col 31.
        write(''') != ''')
        _v = VFFSL(SL,"propDimRep.globalLattice",True) # '${propDimRep.globalLattice}' on line 67, col 61
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.globalLattice}')) # from line 67, col 61.
        write(''')
{
  ''')
        _v = VFN(VFN(VFFSL(SL,"mg",True),"functions",True)['writeOut'],"call",False)(_outfile='NULL') # "${mg.functions['writeOut'].call(_outfile='NULL'), autoIndent=True}" on line 69, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${mg.functions['writeOut'].call(_outfile='NULL'), autoIndent=True}")) # from line 69, col 3.
        write('''
  _LOG(_SIMULATION_LOG_LEVEL, "Written a chunk of moment group ''')
        _v = VFFSL(SL,"mg.number",True)+1 # '${mg.number+1}' on line 70, col 64
        if _v is not None: write(_filter(_v, rawExpr='${mg.number+1}')) # from line 70, col 64.
        write('''\\n");
  ''')
        _v = VFFSL(SL,"propDimRep.localOffset",True) # '${propDimRep.localOffset}' on line 71, col 3
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localOffset}')) # from line 71, col 3.
        write(''' += ''')
        _v = VFFSL(SL,"propDimRep.index",True) # '${propDimRep.index}' on line 71, col 32
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.index}')) # from line 71, col 32.
        write(''';
  ''')
        _v = VFFSL(SL,"propDimRep.index",True) # '${propDimRep.index}' on line 72, col 3
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.index}')) # from line 72, col 3.
        write(''' = 0;
''')
        if mg.integratingComponents: # generated from line 73, col 3
            write('''  ''')
            _v = VFFSL(SL,"mg.rawVector.initialise",True) # '${mg.rawVector.initialise, autoIndent=True}' on line 74, col 3
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${mg.rawVector.initialise, autoIndent=True}')) # from line 74, col 3.
        write('''}
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeOutBegin(self, dict, **KWS):



        ## CHEETAH: generated from @def writeOutBegin($dict) at line 79, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        for mg in VFFSL(SL,"momentGroups",True): # generated from line 81, col 3
            propDimRep = mg.propDimRep
            if not propDimRep: # generated from line 83, col 5
                continue
            _v = VFFSL(SL,"propDimRep.localLattice",True) # '${propDimRep.localLattice}' on line 86, col 1
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.localLattice}')) # from line 86, col 1.
            write(''' = ''')
            _v = VFFSL(SL,"propDimRep.index",True) # '${propDimRep.index}' on line 86, col 30
            if _v is not None: write(_filter(_v, rawExpr='${propDimRep.index}')) # from line 86, col 30.
            write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # ChunkedOutput.tmpl
        # 
        # Created by Graham Dennis on 2010-09-17.
        # 
        # Copyright (c) 2010-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''




''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    featureName = 'ChunkedOutput'

    _mainCheetahMethod_for_ChunkedOutput = 'writeBody'

## END CLASS DEFINITION

if not hasattr(ChunkedOutput, '_initCheetahAttributes'):
    templateAPIClass = getattr(ChunkedOutput,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ChunkedOutput)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ChunkedOutput()).run()


