#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Features.Transforms._NoTransformMPI import _NoTransformMPI

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'NoTransformMPI.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class NoTransformMPI(_NoTransformMPI):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(NoTransformMPI, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: MPI-distributed dimension control at line 25, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''MPI-distributed dimension control''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def setLocalLatticeAndOffsetVariables(self, **KWS):



        ## CHEETAH: generated from @def setLocalLatticeAndOffsetVariables at line 27, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''// First work out the local lattice and offset for the geometry
''')
        mpiDimRep = VFN(VFFSL(SL,"mpiDimension",True),"representations",True)[0]
        write('''// Set the block size for most ranks to lattice/processors rounded up
ptrdiff_t _block_size = (''')
        _v = VFFSL(SL,"mpiDimRep.globalLattice",True) # '${mpiDimRep.globalLattice}' on line 32, col 26
        if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.globalLattice}')) # from line 32, col 26.
        write('''-1)/_size + 1;
''')
        _v = VFFSL(SL,"mpiDimRep.localOffset",True) # '${mpiDimRep.localOffset}' on line 33, col 1
        if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localOffset}')) # from line 33, col 1.
        write(''' = _rank * _block_size;
if (_rank != _size - 1)
  ''')
        _v = VFFSL(SL,"mpiDimRep.localLattice",True) # '${mpiDimRep.localLattice}' on line 35, col 3
        if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localLattice}')) # from line 35, col 3.
        write(""" = _block_size;
else {
  // The last rank takes up everything else
  // this should be less than or equal to _block_size
  // And if there's nothing left, we don't have a local lattice.
  """)
        _v = VFFSL(SL,"mpiDimRep.localLattice",True) # '${mpiDimRep.localLattice}' on line 40, col 3
        if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localLattice}')) # from line 40, col 3.
        write(''' = MAX(''')
        _v = VFFSL(SL,"mpiDimRep.globalLattice",True) # '${mpiDimRep.globalLattice}' on line 40, col 35
        if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.globalLattice}')) # from line 40, col 35.
        write(''' - _block_size * (_size - 1), 0);
}

''')
        for field in VFFSL(SL,"fields",True): # generated from line 43, col 3
            if field.name == 'geometry' or not VFFSL(SL,"isFieldDistributed",False)(field): # generated from line 44, col 5
                continue
            #  Set the local_lattice and local_offset variables based on the
            #  values for the geometry's version of these variables
            fieldMPIDimRep = field.dimensionWithName(VFFSL(SL,"mpiDimension.name",True)).representations[0]
            write("""// Set the local_lattice and local_offset variables for the '""")
            _v = VFFSL(SL,"field.name",True) # '${field.name}' on line 50, col 62
            if _v is not None: write(_filter(_v, rawExpr='${field.name}')) # from line 50, col 62.
            write("""' field.
ptrdiff_t _""")
            _v = VFFSL(SL,"field.name",True) # '${field.name}' on line 51, col 12
            if _v is not None: write(_filter(_v, rawExpr='${field.name}')) # from line 51, col 12.
            write('''_skip_size = ''')
            _v = VFFSL(SL,"mpiDimRep.globalLattice",True) # '${mpiDimRep.globalLattice}' on line 51, col 38
            if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.globalLattice}')) # from line 51, col 38.
            write('''/''')
            _v = VFFSL(SL,"fieldMPIDimRep.globalLattice",True) # '${fieldMPIDimRep.globalLattice}' on line 51, col 65
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.globalLattice}')) # from line 51, col 65.
            write(''';
if (_rank == 0) {
  ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localOffset",True) # '${fieldMPIDimRep.localOffset}' on line 53, col 3
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localOffset}')) # from line 53, col 3.
            write(''' = 0;
  ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localLattice",True) # '${fieldMPIDimRep.localLattice}' on line 54, col 3
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localLattice}')) # from line 54, col 3.
            write(''' = (''')
            _v = VFFSL(SL,"mpiDimRep.localLattice",True) # '${mpiDimRep.localLattice}' on line 54, col 37
            if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localLattice}')) # from line 54, col 37.
            write('''-1)/_''')
            _v = VFFSL(SL,"field.name",True) # '${field.name}' on line 54, col 67
            if _v is not None: write(_filter(_v, rawExpr='${field.name}')) # from line 54, col 67.
            write('''_skip_size + 1;
} else {
  ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localOffset",True) # '${fieldMPIDimRep.localOffset}' on line 56, col 3
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localOffset}')) # from line 56, col 3.
            write(''' = (''')
            _v = VFFSL(SL,"mpiDimRep.localOffset",True) # '${mpiDimRep.localOffset}' on line 56, col 36
            if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localOffset}')) # from line 56, col 36.
            write('''-1)/_''')
            _v = VFFSL(SL,"field.name",True) # '${field.name}' on line 56, col 65
            if _v is not None: write(_filter(_v, rawExpr='${field.name}')) # from line 56, col 65.
            write('''_skip_size + 1;
  ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localLattice",True) # '${fieldMPIDimRep.localLattice}' on line 57, col 3
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localLattice}')) # from line 57, col 3.
            write(''' = MIN((''')
            _v = VFFSL(SL,"mpiDimRep.localOffset",True) # '${mpiDimRep.localOffset}' on line 57, col 41
            if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localOffset}')) # from line 57, col 41.
            write(''' + ''')
            _v = VFFSL(SL,"mpiDimRep.localLattice",True) # '${mpiDimRep.localLattice}' on line 57, col 68
            if _v is not None: write(_filter(_v, rawExpr='${mpiDimRep.localLattice}')) # from line 57, col 68.
            write(''' - 1)/_''')
            _v = VFFSL(SL,"field.name",True) # '${field.name}' on line 57, col 100
            if _v is not None: write(_filter(_v, rawExpr='${field.name}')) # from line 57, col 100.
            write('''_skip_size
                                         + 1 - ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localOffset",True) # '${fieldMPIDimRep.localOffset}' on line 58, col 48
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localOffset}')) # from line 58, col 48.
            write(''', MAX(''')
            _v = VFFSL(SL,"fieldMPIDimRep.globalLattice",True) # '${fieldMPIDimRep.globalLattice}' on line 58, col 83
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.globalLattice}')) # from line 58, col 83.
            write(''' - ''')
            _v = VFFSL(SL,"fieldMPIDimRep.localOffset",True) # '${fieldMPIDimRep.localOffset}' on line 58, col 117
            if _v is not None: write(_filter(_v, rawExpr='${fieldMPIDimRep.localOffset}')) # from line 58, col 117.
            write(''', 0));
}

''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # NoTransformMPI.tmpl
        # 
        # Created by Graham Dennis on 2008-08-24.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_NoTransformMPI = 'writeBody'

## END CLASS DEFINITION

if not hasattr(NoTransformMPI, '_initCheetahAttributes'):
    templateAPIClass = getattr(NoTransformMPI,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(NoTransformMPI)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=NoTransformMPI()).run()


