#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Geometry._NonUniformDimensionRepresentation import _NonUniformDimensionRepresentation

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'NonUniformDimensionRepresentation.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class NonUniformDimensionRepresentation(_NonUniformDimensionRepresentation):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(NonUniformDimensionRepresentation, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def defines(self, **KWS):



        ## CHEETAH: generated from @def defines at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"silent",True): # generated from line 28, col 3
            return _dummyTrans and trans.response().getvalue() or ""
        if VFFSL(SL,"runtimeLattice",True): # generated from line 31, col 3
            _v = super(NonUniformDimensionRepresentation, self).defines()
            if _v is not None: write(_filter(_v))
            write('''#define ''')
            _v = VFFSL(SL,"minimum",True) # '${minimum}' on line 33, col 9
            if _v is not None: write(_filter(_v, rawExpr='${minimum}')) # from line 33, col 9.
            write('''     (''')
            _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 33, col 25
            if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 33, col 25.
            write('''[0])
#define ''')
            _v = VFFSL(SL,"maximum",True) # '${maximum}' on line 34, col 9
            if _v is not None: write(_filter(_v, rawExpr='${maximum}')) # from line 34, col 9.
            write('''     (''')
            _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 34, col 25
            if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 34, col 25.
            write('''[''')
            _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 34, col 38
            if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 34, col 38.
            write('''-1])
''')
            if not VFFSL(SL,"stepSizeArray",True): # generated from line 35, col 5
                write('''#define ''')
                _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 36, col 9
                if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 36, col 9.
                write('''        (''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 36, col 29
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 36, col 29.
                write('''[''')
                _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 36, col 42
                if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 36, col 42.
                write('''+1]-''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 36, col 58
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 36, col 58.
                write('''[''')
                _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 36, col 71
                if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 36, col 71.
                write('''])
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def globals(self, **KWS):



        ## CHEETAH: generated from @def globals at line 42, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"silent",True): # generated from line 44, col 3
            return _dummyTrans and trans.response().getvalue() or ""
        # 
        _v = super(NonUniformDimensionRepresentation, self).globals()
        if _v is not None: write(_filter(_v))
        # 
        if VFFSL(SL,"runtimeLattice",True): # generated from line 50, col 3
            if VFFSL(SL,"stepSizeArray",True): # generated from line 51, col 5
                _v = VFFSL(SL,"type",True) # '${type}' on line 52, col 1
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 52, col 1.
                write('''* ''')
                _v = VFFSL(SL,"stepSizeArrayName",True) # '${stepSizeArrayName}' on line 52, col 10
                if _v is not None: write(_filter(_v, rawExpr='${stepSizeArrayName}')) # from line 52, col 10.
                write(''' = (''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 52, col 34
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 52, col 34.
                write('''*) xmds_malloc(sizeof(''')
                _v = VFFSL(SL,"type",True) # '${type}' on line 52, col 63
                if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 52, col 63.
                write(''') * (''')
                _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 52, col 75
                if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 52, col 75.
                write('''));
''')
            else: # generated from line 53, col 5
                write('''unsigned long ''')
                _v = VFFSL(SL,"index",True) # '${index}' on line 54, col 15
                if _v is not None: write(_filter(_v, rawExpr='${index}')) # from line 54, col 15.
                write(''' = 0;
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def openLoopAscending(self, **KWS):



        ## CHEETAH: generated from @def openLoopAscending at line 60, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''#define ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 62, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 62, col 9.
        write(''' ''')
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 62, col 17
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 62, col 17.
        write('''[''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 62, col 30
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 62, col 30.
        write(''' + ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 62, col 45
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 62, col 45.
        write(''']
''')
        if VFFSL(SL,"stepSizeArray",True): # generated from line 63, col 3
            write('''#define d''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 64, col 10
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 64, col 10.
            write(''' (''')
            _v = VFFSL(SL,"stepSizeArrayName",True) # '${stepSizeArrayName}' on line 64, col 19
            if _v is not None: write(_filter(_v, rawExpr='${stepSizeArrayName}')) # from line 64, col 19.
            write('''[''')
            _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 64, col 40
            if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 64, col 40.
            write(''' + ''')
            _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 64, col 55
            if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 64, col 55.
            write('''] * (''')
            _v = VFFSL(SL,"volumePrefactor",True) # '${volumePrefactor}' on line 64, col 74
            if _v is not None: write(_filter(_v, rawExpr='${volumePrefactor}')) # from line 64, col 74.
            write('''))
''')
        write('''
for (long ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 67, col 11
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 67, col 11.
        write(''' = 0; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 67, col 29
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 67, col 29.
        write(''' < ''')
        _v = VFFSL(SL,"localLattice",True) # '${localLattice}' on line 67, col 44
        if _v is not None: write(_filter(_v, rawExpr='${localLattice}')) # from line 67, col 44.
        write('''; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 67, col 61
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 67, col 61.
        write('''++) {
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def closeLoopAscending(self, **KWS):



        ## CHEETAH: generated from @def closeLoopAscending at line 70, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''}
#undef ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 73, col 8
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 73, col 8.
        write('''
''')
        if VFFSL(SL,"stepSizeArray",True): # generated from line 74, col 3
            write('''#undef d''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 75, col 9
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 75, col 9.
            write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def localIndexFromIndexForDimensionRep(self, dimRep, **KWS):



        ## CHEETAH: generated from @def localIndexFromIndexForDimensionRep($dimRep) at line 80, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''(''')
        _v = VFFSL(SL,"dimRep.loopIndex",True) # '${dimRep.loopIndex}' on line 82, col 2
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.loopIndex}')) # from line 82, col 2.
        write(''' + ''')
        _v = VFFSL(SL,"dimRep.localOffset",True) # '${dimRep.localOffset}' on line 82, col 24
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.localOffset}')) # from line 82, col 24.
        write(''') * (''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 82, col 50
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 82, col 50.
        write('''/''')
        _v = VFFSL(SL,"dimRep.globalLattice",True) # '${dimRep.globalLattice}' on line 82, col 67
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.globalLattice}')) # from line 82, col 67.
        write(''') - ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 82, col 94
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 82, col 94.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def strictlyAscendingGlobalIndex(self, **KWS):



        ## CHEETAH: generated from @def strictlyAscendingGlobalIndex at line 86, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 88, col 1
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 88, col 1.
        write(''' + ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 88, col 16
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 88, col 16.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def initialiseArray(self, **KWS):



        ## CHEETAH: generated from @def initialiseArray at line 92, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"stepSizeArray",True): # generated from line 94, col 3
            write('''for (long ''')
            _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 95, col 11
            if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 95, col 11.
            write(''' = 0; ''')
            _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 95, col 29
            if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 95, col 29.
            write(''' < ''')
            _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 95, col 44
            if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 95, col 44.
            write('''; ''')
            _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 95, col 62
            if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 95, col 62.
            write('''++) {
  ''')
            _v = VFFSL(SL,"gridAndStepAtIndex",False)(self.loopIndex) # '${gridAndStepAtIndex(self.loopIndex), autoIndent=True}' on line 96, col 3
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${gridAndStepAtIndex(self.loopIndex), autoIndent=True}')) # from line 96, col 3.
            write('''}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def gridAndStepAtIndex(self, index, **KWS):



        ## CHEETAH: generated from @def gridAndStepAtIndex($index) at line 102, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 104, col 1
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 104, col 1.
        write('''[''')
        _v = VFFSL(SL,"index",True) # '$index' on line 104, col 14
        if _v is not None: write(_filter(_v, rawExpr='$index')) # from line 104, col 14.
        write('''] = ''')
        _v = VFFSL(SL,"gridAtIndex",False)(index) # '${gridAtIndex(index)}' on line 104, col 24
        if _v is not None: write(_filter(_v, rawExpr='${gridAtIndex(index)}')) # from line 104, col 24.
        write(''';
''')
        _v = VFFSL(SL,"stepSizeArrayName",True) # '${stepSizeArrayName}' on line 105, col 1
        if _v is not None: write(_filter(_v, rawExpr='${stepSizeArrayName}')) # from line 105, col 1.
        write('''[''')
        _v = VFFSL(SL,"index",True) # '$index' on line 105, col 22
        if _v is not None: write(_filter(_v, rawExpr='$index')) # from line 105, col 22.
        write('''] = ''')
        _v = VFFSL(SL,"stepWeightAtIndex",False)(index) # '${stepWeightAtIndex(index)}' on line 105, col 32
        if _v is not None: write(_filter(_v, rawExpr='${stepWeightAtIndex(index)}')) # from line 105, col 32.
        write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # NonUniformDimensionRepresentation.tmpl
        # 
        # Created by Graham Dennis on 2008-07-30.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''







''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_NonUniformDimensionRepresentation = 'writeBody'

## END CLASS DEFINITION

if not hasattr(NonUniformDimensionRepresentation, '_initCheetahAttributes'):
    templateAPIClass = getattr(NonUniformDimensionRepresentation,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(NonUniformDimensionRepresentation)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=NonUniformDimensionRepresentation()).run()


