#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Geometry._SplitUniformDimensionRepresentation import _SplitUniformDimensionRepresentation

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'SplitUniformDimensionRepresentation.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SplitUniformDimensionRepresentation(_SplitUniformDimensionRepresentation):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(SplitUniformDimensionRepresentation, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def defines(self, **KWS):



        ## CHEETAH: generated from @def defines at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(SplitUniformDimensionRepresentation, self).defines()
        if _v is not None: write(_filter(_v))
        if VFFSL(SL,"silent",True): # generated from line 29, col 3
            return _dummyTrans and trans.response().getvalue() or ""
        # 
        write('''#define ''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 33, col 9
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 33, col 9.
        write('''        (2.0*M_PI/(''')
        _v = VFFSL(SL,"_range",True) # '$_range' on line 33, col 39
        if _v is not None: write(_filter(_v, rawExpr='$_range')) # from line 33, col 39.
        write('''))
#define ''')
        _v = VFFSL(SL,"minimum",True) # '${minimum}' on line 34, col 9
        if _v is not None: write(_filter(_v, rawExpr='${minimum}')) # from line 34, col 9.
        write('''     (-(''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 34, col 27
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 34, col 27.
        write('''/2) * ''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 34, col 49
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 34, col 49.
        write(''')
#define ''')
        _v = VFFSL(SL,"maximum",True) # '${maximum}' on line 35, col 9
        if _v is not None: write(_filter(_v, rawExpr='${maximum}')) # from line 35, col 9.
        write('''     ((''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 35, col 26
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 35, col 26.
        write(''' - 1)/2 * ''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 35, col 52
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 35, col 52.
        write(''')
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def openLoopMemoryOrder(self, **KWS):



        ## CHEETAH: generated from @def openLoopMemoryOrder at line 39, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''#define ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 41, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 41, col 9.
        write(''' ''')
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 41, col 17
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 41, col 17.
        write('''[''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 41, col 30
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 41, col 30.
        write(''' + ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 41, col 45
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 41, col 45.
        write(''']
#define d''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 42, col 10
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 42, col 10.
        write(''' (''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 42, col 19
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 42, col 19.
        write(''' * (''')
        _v = VFFSL(SL,"volumePrefactor",True) # '${volumePrefactor}' on line 42, col 34
        if _v is not None: write(_filter(_v, rawExpr='${volumePrefactor}')) # from line 42, col 34.
        write('''))

for (long ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 44, col 11
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 44, col 11.
        write(''' = 0; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 44, col 29
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 44, col 29.
        write(''' < ''')
        _v = VFFSL(SL,"localLattice",True) # '${localLattice}' on line 44, col 44
        if _v is not None: write(_filter(_v, rawExpr='${localLattice}')) # from line 44, col 44.
        write('''; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 44, col 61
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 44, col 61.
        write('''++) {
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def closeLoopMemoryOrder(self, **KWS):



        ## CHEETAH: generated from @def closeLoopMemoryOrder at line 48, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''}
#undef ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 51, col 8
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 51, col 8.
        write('''
#undef d''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 52, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 52, col 9.
        write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def openLoopAscending(self, **KWS):



        ## CHEETAH: generated from @def openLoopAscending at line 56, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''#define ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 58, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 58, col 9.
        write(''' ''')
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 58, col 17
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 58, col 17.
        write('''[''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 58, col 30
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 58, col 30.
        write(''' + ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 58, col 45
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 58, col 45.
        write(''']
#define d''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 59, col 10
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 59, col 10.
        write(''' (''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 59, col 19
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 59, col 19.
        write(''' * (''')
        _v = VFFSL(SL,"volumePrefactor",True) # '${volumePrefactor}' on line 59, col 34
        if _v is not None: write(_filter(_v, rawExpr='${volumePrefactor}')) # from line 59, col 34.
        write('''))

for (long ''')
        _v = VFFSL(SL,"alternateLoopIndex",True) # '${alternateLoopIndex}' on line 61, col 11
        if _v is not None: write(_filter(_v, rawExpr='${alternateLoopIndex}')) # from line 61, col 11.
        write(''' = -(''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 61, col 37
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 61, col 37.
        write('''/2); ''')
        _v = VFFSL(SL,"alternateLoopIndex",True) # '${alternateLoopIndex}' on line 61, col 58
        if _v is not None: write(_filter(_v, rawExpr='${alternateLoopIndex}')) # from line 61, col 58.
        write(''' < (''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 61, col 83
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 61, col 83.
        write(''' + 1)/2; ''')
        _v = VFFSL(SL,"alternateLoopIndex",True) # '${alternateLoopIndex}' on line 61, col 108
        if _v is not None: write(_filter(_v, rawExpr='${alternateLoopIndex}')) # from line 61, col 108.
        write('''++) {
  long ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 62, col 8
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 62, col 8.
        write(''' = ''')
        _v = VFFSL(SL,"alternateLoopIndex",True) # '${alternateLoopIndex}' on line 62, col 23
        if _v is not None: write(_filter(_v, rawExpr='${alternateLoopIndex}')) # from line 62, col 23.
        write(''';
  if (''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 63, col 7
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 63, col 7.
        write(''' < 0)
    ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 64, col 5
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 64, col 5.
        write(''' += ''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 64, col 21
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 64, col 21.
        write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def closeLoopAscending(self, **KWS):



        ## CHEETAH: generated from @def closeLoopAscending at line 68, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''}
#undef ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 71, col 8
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 71, col 8.
        write('''
#undef d''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 72, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 72, col 9.
        write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def localIndexFromIndexForDimensionRep(self, dimRep, **KWS):



        ## CHEETAH: generated from @def localIndexFromIndexForDimensionRep($dimRep) at line 76, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Check that our lattice has more points than the other lattice (provided we
        #  know how many points each lattice actually has - if the lattice is defined
        #  at runtime we'll just have string rather than a number, so we can't judge).
        assert isinstance(VFFSL(SL,"runtimeLattice",True), basestring) or isinstance(dimRep.runtimeLattice, basestring) or VFFSL(SL,"runtimeLattice",True) >= dimRep.runtimeLattice
        # 
        _v = VFFSL(SL,"dimRep.loopIndex",True) # '${dimRep.loopIndex}' on line 82, col 1
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.loopIndex}')) # from line 82, col 1.
        write(''' + ''')
        _v = VFFSL(SL,"dimRep.localOffset",True) # '${dimRep.localOffset}' on line 82, col 23
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.localOffset}')) # from line 82, col 23.
        write(''' - ''')
        _v = VFFSL(SL,"localOffset",True) # '${localOffset}' on line 82, col 47
        if _v is not None: write(_filter(_v, rawExpr='${localOffset}')) # from line 82, col 47.
        write(''' + (signbit(''')
        _v = VFFSL(SL,"dimRep.name",True) # '${dimRep.name}' on line 82, col 73
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.name}')) # from line 82, col 73.
        write(''') ? (''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 82, col 92
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 82, col 92.
        write(''' - ''')
        _v = VFFSL(SL,"dimRep.globalLattice",True) # '${dimRep.globalLattice}' on line 82, col 111
        if _v is not None: write(_filter(_v, rawExpr='${dimRep.globalLattice}')) # from line 82, col 111.
        write(''') : 0)''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def strictlyAscendingGlobalIndex(self, **KWS):



        ## CHEETAH: generated from @def strictlyAscendingGlobalIndex at line 86, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if not VFFSL(SL,"hasLocalOffset",True): # generated from line 88, col 3
            _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 89, col 1
            if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 89, col 1.
            write(''' + (signbit(''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 89, col 25
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 89, col 25.
            write(''') ? -(''')
            _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 89, col 38
            if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 89, col 38.
            write('''+1)/2 : ''')
            _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 89, col 62
            if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 89, col 62.
            write('''/2)''')
        else: # generated from line 90, col 3
            write('''lround(''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 91, col 8
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 91, col 8.
            write('''/''')
            _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 91, col 16
            if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 91, col 16.
            write(''') + ''')
            _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 91, col 31
            if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 91, col 31.
            write('''/2''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def indexForSinglePointSample(self, **KWS):



        ## CHEETAH: generated from @def indexForSinglePointSample at line 96, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  We want to sample the middle, as that is just the first point in memory, return 0
        #  (Don't worry about multiplication by zero, any smart compiler will optimise that out)
        write('''0''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def createCoordinateVariableForSinglePointSample(self, **KWS):



        ## CHEETAH: generated from @def createCoordinateVariableForSinglePointSample at line 104, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"type",True) # '${type}' on line 106, col 1
        if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 106, col 1.
        write(''' ''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 106, col 9
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 106, col 9.
        write(''' = 0.0;
#define d''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 107, col 10
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 107, col 10.
        write(''' (''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 107, col 19
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 107, col 19.
        write(''' * (''')
        _v = VFFSL(SL,"volumePrefactor",True) # '${volumePrefactor}' on line 107, col 34
        if _v is not None: write(_filter(_v, rawExpr='${volumePrefactor}')) # from line 107, col 34.
        write('''))
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def initialiseArray(self, **KWS):



        ## CHEETAH: generated from @def initialiseArray at line 111, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''for (long ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 113, col 11
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 113, col 11.
        write(''' = 0; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 113, col 29
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 113, col 29.
        write(''' < (''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 113, col 45
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 113, col 45.
        write('''+1)/2; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 113, col 68
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 113, col 68.
        write('''++)
  ''')
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 114, col 3
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 114, col 3.
        write('''[''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 114, col 16
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 114, col 16.
        write('''] = ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 114, col 32
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 114, col 32.
        write('''*''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 114, col 45
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 114, col 45.
        write(''';
for (long ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 115, col 11
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 115, col 11.
        write(''' = (''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 115, col 27
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 115, col 27.
        write('''+1)/2; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 115, col 50
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 115, col 50.
        write(''' < ''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 115, col 65
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 115, col 65.
        write('''; ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 115, col 83
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 115, col 83.
        write('''++)
  ''')
        _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 116, col 3
        if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 116, col 3.
        write('''[''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 116, col 16
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 116, col 16.
        write('''] = -(''')
        _v = VFFSL(SL,"globalLattice",True) # '${globalLattice}' on line 116, col 34
        if _v is not None: write(_filter(_v, rawExpr='${globalLattice}')) # from line 116, col 34.
        write(''' - ''')
        _v = VFFSL(SL,"loopIndex",True) # '${loopIndex}' on line 116, col 53
        if _v is not None: write(_filter(_v, rawExpr='${loopIndex}')) # from line 116, col 53.
        write(''') * ''')
        _v = VFFSL(SL,"stepSize",True) # '${stepSize}' on line 116, col 69
        if _v is not None: write(_filter(_v, rawExpr='${stepSize}')) # from line 116, col 69.
        write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # SplitUniformDimensionRepresentation.tmpl
        # 
        # Created by Graham Dennis on 2008-07-31.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''










''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_SplitUniformDimensionRepresentation = 'writeBody'

## END CLASS DEFINITION

if not hasattr(SplitUniformDimensionRepresentation, '_initCheetahAttributes'):
    templateAPIClass = getattr(SplitUniformDimensionRepresentation,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SplitUniformDimensionRepresentation)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SplitUniformDimensionRepresentation()).run()


