#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Segments.Integrators._FixedStep import _FixedStep

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'FixedStep.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class FixedStep(_FixedStep):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(FixedStep, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: segment $segmentNumber ($stepper.name fixed-step integrator) at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''segment ''')
        _v = VFFSL(SL,"segmentNumber",True) # '$segmentNumber' on line 26, col 27
        if _v is not None: write(_filter(_v, rawExpr='$segmentNumber')) # from line 26, col 27.
        write(''' (''')
        _v = VFFSL(SL,"stepper.name",True) # '$stepper.name' on line 26, col 43
        if _v is not None: write(_filter(_v, rawExpr='$stepper.name')) # from line 26, col 43.
        write(''' fixed-step integrator)''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def functionPrototypes(self, **KWS):



        ## CHEETAH: generated from @def functionPrototypes at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(FixedStep, self).functionPrototypes()
        if _v is not None: write(_filter(_v))
        # 
        if VFFSL(SL,"cross",True): # generated from line 33, col 3
            write('''void _''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 34, col 7
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 34, col 7.
            write('''_initialise_cross_propagation();
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def functionImplementations(self, **KWS):



        ## CHEETAH: generated from @def functionImplementations at line 39, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(FixedStep, self).functionImplementations()
        if _v is not None: write(_filter(_v))
        # 
        if VFFSL(SL,"cross",True): # generated from line 43, col 3
            write('''
''')
            _v = VFFSL(SL,"initialiseCrossPropagationFunctionImplementation",True) # '${initialiseCrossPropagationFunctionImplementation}' on line 45, col 1
            if _v is not None: write(_filter(_v, rawExpr='${initialiseCrossPropagationFunctionImplementation}')) # from line 45, col 1.
            write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def localInitialise(self, **KWS):


        """
        This function returns the local initialisation code for the integrator.
        """

        ## CHEETAH: generated from @def localInitialise at line 51, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(FixedStep, self).localInitialise()
        if _v is not None: write(_filter(_v))
        # 
        if VFFSL(SL,"cross",True): # generated from line 58, col 3
            write('''
_''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 60, col 2
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 60, col 2.
            write('''_initialise_cross_propagation();

''')
            integrationDimRep = VFN(VFN(VFFSL(SL,"parent.field",True),"dimensionWithName",False)(VFFSL(SL,"propagationDimension",True)),"inBasis",False)(VFFSL(SL,"parent.operatorBasis",True))
            if VFFSL(SL,"propagationDirection",True) == '+': # generated from line 63, col 5
                initialValue = integrationDimRep.minimum
            else: # generated from line 65, col 5
                initialValue = integrationDimRep.maximum
            _v = VFFSL(SL,"integrationDimRep.type",True) # '${integrationDimRep.type}' on line 68, col 1
            if _v is not None: write(_filter(_v, rawExpr='${integrationDimRep.type}')) # from line 68, col 1.
            write(''' ''')
            _v = VFFSL(SL,"integrationDimRep.name",True) # '${integrationDimRep.name}' on line 68, col 27
            if _v is not None: write(_filter(_v, rawExpr='${integrationDimRep.name}')) # from line 68, col 27.
            write(''' = ''')
            _v = VFFSL(SL,"initialValue",True) # '${initialValue}' on line 68, col 55
            if _v is not None: write(_filter(_v, rawExpr='${initialValue}')) # from line 68, col 55.
            write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def createStepVariable(self, **KWS):


        """
        This function returns the code that will create a _step variable,
        including any modifications necessary due to the ErrorCheck feature.
        """

        ## CHEETAH: generated from @def createStepVariable at line 74, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''real _step = ''')
        _v = VFFSL(SL,"step",True) # '${step}' on line 80, col 14
        if _v is not None: write(_filter(_v, rawExpr='${step}')) # from line 80, col 14.
        write(''';
real _noiseStep = ''')
        _v = VFFSL(SL,"step",True) # '${step}' on line 81, col 19
        if _v is not None: write(_filter(_v, rawExpr='${step}')) # from line 81, col 19.
        write(''';
''')
        # 
        featureOrdering = ['ErrorCheck']
        # 
        _v = VFFSL(SL,"insertCodeForFeatures",False)('createFixedStepVariable', featureOrdering) # "${insertCodeForFeatures('createFixedStepVariable', featureOrdering)}" on line 85, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeatures('createFixedStepVariable', featureOrdering)}")) # from line 85, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def segmentFunctionBody(self, function, **KWS):



        ## CHEETAH: generated from @def segmentFunctionBody($function) at line 90, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"createStepVariable",True) # '${createStepVariable}' on line 92, col 1
        if _v is not None: write(_filter(_v, rawExpr='${createStepVariable}')) # from line 92, col 1.
        # 
        featureOrderingOuter = ['Stochastic']
        _v = VFFSL(SL,"insertCodeForFeatures",False)('integrateFixedStepBegin', featureOrderingOuter) # "${insertCodeForFeatures('integrateFixedStepBegin', featureOrderingOuter)}" on line 95, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeatures('integrateFixedStepBegin', featureOrderingOuter)}")) # from line 95, col 1.
        write('''
''')
        _v = VFFSL(SL,"allocate",True) # '${allocate}' on line 97, col 1
        if _v is not None: write(_filter(_v, rawExpr='${allocate}')) # from line 97, col 1.
        _v = VFFSL(SL,"initialise",True) # '${initialise}' on line 98, col 1
        if _v is not None: write(_filter(_v, rawExpr='${initialise}')) # from line 98, col 1.
        _v = VFFSL(SL,"localInitialise",True) # '${localInitialise}' on line 99, col 1
        if _v is not None: write(_filter(_v, rawExpr='${localInitialise}')) # from line 99, col 1.
        write('''
for (long _istep = 0; _istep < ''')
        _v = VFFSL(SL,"stepCount",True) # '${stepCount}' on line 101, col 32
        if _v is not None: write(_filter(_v, rawExpr='${stepCount}')) # from line 101, col 32.
        write('''; _istep++) {
''')
        #  Insert code for features
        featureOrderingInner = ['Output', 'ErrorCheck', 'Stochastic']
        # 
        dict = {'extraIndent': 0}
        write('''  ''')
        _v = VFFSL(SL,"insertCodeForFeatures",False)('integrateFixedStepInnerLoopBegin', featureOrderingInner, dict) # "${insertCodeForFeatures('integrateFixedStepInnerLoopBegin', featureOrderingInner, dict), autoIndent=True}" on line 106, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${insertCodeForFeatures('integrateFixedStepInnerLoopBegin', featureOrderingInner, dict), autoIndent=True}")) # from line 106, col 3.
        extraIndent = VFFSL(SL,"dict.extraIndent",True)
        write('''  
  ''')
        _v = VFFSL(SL,"preSingleStep",True) # '${preSingleStep, autoIndent=True, extraIndent=extraIndent}' on line 109, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, extraIndent=extraIndent, rawExpr='${preSingleStep, autoIndent=True, extraIndent=extraIndent}')) # from line 109, col 3.
        write('''  ''')
        _v = VFN(VFFSL(SL,"stepper",True),"singleIntegrationStep",False)(function) # '${stepper.singleIntegrationStep(function), autoIndent=True, extraIndent=extraIndent}' on line 110, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, extraIndent=extraIndent, rawExpr='${stepper.singleIntegrationStep(function), autoIndent=True, extraIndent=extraIndent}')) # from line 110, col 3.
        write('''  ''')
        _v = VFFSL(SL,"postSingleStep",True) # '${postSingleStep, autoIndent=True, extraIndent=extraIndent}' on line 111, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, extraIndent=extraIndent, rawExpr='${postSingleStep, autoIndent=True, extraIndent=extraIndent}')) # from line 111, col 3.
        write('''  
''')
        if VFFSL(SL,"cross",True): # generated from line 113, col 3
            #  If we are cross-integrating, then we now need to copy our result back
            #  into the original arrays for the integration vectors
            write('''  ''')
            _v = VFFSL(SL,"copyResultIntoIntegrationArrays",True) # '${copyResultIntoIntegrationArrays, autoIndent=True, extraIndent=extraIndent}' on line 116, col 3
            if _v is not None: write(_filter(_v, autoIndent=True, extraIndent=extraIndent, rawExpr='${copyResultIntoIntegrationArrays, autoIndent=True, extraIndent=extraIndent}')) # from line 116, col 3.
            write('''  
''')
        # 
        write('''  ''')
        _v = VFFSL(SL,"insertCodeForFeaturesInReverseOrder",False)('integrateFixedStepInnerLoopEnd', featureOrderingInner, dict) # "${insertCodeForFeaturesInReverseOrder('integrateFixedStepInnerLoopEnd', featureOrderingInner, dict), autoIndent=True}" on line 120, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${insertCodeForFeaturesInReverseOrder('integrateFixedStepInnerLoopEnd', featureOrderingInner, dict), autoIndent=True}")) # from line 120, col 3.
        write('''}

''')
        _v = VFFSL(SL,"localFinalise",True) # '${localFinalise}' on line 123, col 1
        if _v is not None: write(_filter(_v, rawExpr='${localFinalise}')) # from line 123, col 1.
        _v = VFFSL(SL,"finalise",True) # '${finalise}' on line 124, col 1
        if _v is not None: write(_filter(_v, rawExpr='${finalise}')) # from line 124, col 1.
        _v = VFFSL(SL,"free",True) # '${free}' on line 125, col 1
        if _v is not None: write(_filter(_v, rawExpr='${free}')) # from line 125, col 1.
        write('''
''')
        _v = VFFSL(SL,"insertCodeForFeaturesInReverseOrder",False)('integrateFixedStepEnd', featureOrderingOuter) # "${insertCodeForFeaturesInReverseOrder('integrateFixedStepEnd', featureOrderingOuter)}" on line 127, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeaturesInReverseOrder('integrateFixedStepEnd', featureOrderingOuter)}")) # from line 127, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def reducedFieldCopy(self, vectorMap, templateString, positiveIndexOverride=None, negativeIndexOverride=None, **KWS):



        ## CHEETAH: generated from @def reducedFieldCopy($vectorMap, $templateString, $positiveIndexOverride = None, $negativeIndexOverride = None) at line 134, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"propagationDirection",True) == '+': # generated from line 136, col 3
            if VFFSL(SL,"positiveIndexOverride",True): # generated from line 137, col 5
                indexOverrideValue = VFFSL(SL,"positiveIndexOverride",True)
            else: # generated from line 139, col 5
                indexOverrideValue = '_istep'
        else: # generated from line 142, col 3
            if VFFSL(SL,"negativeIndexOverride",True): # generated from line 143, col 5
                indexOverrideValue = VFFSL(SL,"negativeIndexOverride",True)
            else: # generated from line 145, col 5
                propDimRep = VFN(VFN(VFFSL(SL,"parent.field",True),"dimensionWithName",False)(VFFSL(SL,"propagationDimension",True)),"inBasis",False)(VFFSL(SL,"parent.operatorBasis",True))
                indexOverrideValue = ''.join(['(',str(VFFSL(SL,"propDimRep.globalLattice",True)),' - _istep - 1)'])
        # 
        #  Create the index overrides dictionary. We only need to override the propagation dimension
        indexOverrides = {VFFSL(SL,"propagationDimension",True): dict([(v.field, indexOverrideValue) for v in vectorMap.values()])}
        # 
        setOfVectorsToLoopOver = set(vectorMap.keys())
        setOfVectorsToLoopOver.update(vectorMap.values())
        # 
        innerLoopTemplate = VFFSL(SL,"templateObjectFromStringWithTemplateVariables",False)(VFFSL(SL,"templateString",True), {'componentIndex': '_icomp'})
        # 
        ## START CAPTURE REGION: _58856930 loopContents at line 159, col 3 in the source.
        _orig_trans_58856930 = trans
        _wasBuffering_58856930 = self._CHEETAH__isBuffering
        self._CHEETAH__isBuffering = True
        trans = _captureCollector_58856930 = DummyTransaction()
        write = _captureCollector_58856930.response().write
        for reducedVector, vector in VFN(VFFSL(SL,"vectorMap",True),"items",False)(): # generated from line 160, col 5
            if vector.field.hasDimensionName(VFFSL(SL,"propagationDimension",True)): # generated from line 161, col 7
                propagationDimensionObject = vector.field.dimensionWithName(VFFSL(SL,"propagationDimension",True))
                innerLoopTemplate.skipSize = VFFSL(SL,"propagationDirection",True) +                                              VFN(VFFSL(SL,"vector.field",True),"localPointsInDimensionsAfterDimRepInBasis",False)(propagationDimensionObject.inBasis(VFFSL(SL,"homeBasis",True)), VFFSL(SL,"homeBasis",True))
            innerLoopTemplate.reducedVector = reducedVector
            innerLoopTemplate.vector = vector
            write('''for (long _icomp = 0; _icomp < _''')
            _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 168, col 33
            if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 168, col 33.
            write('''_ncomponents; _icomp++) {
  ''')
            _v = VFFSL(SL,"innerLoopTemplate",True) # '${innerLoopTemplate, autoIndent=True}' on line 169, col 3
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${innerLoopTemplate, autoIndent=True}')) # from line 169, col 3.
            write('''}
''')
            del innerLoopTemplate.skipSize
        trans = _orig_trans_58856930
        write = trans.response().write
        self._CHEETAH__isBuffering = _wasBuffering_58856930 
        loopContents = _captureCollector_58856930.response().getvalue()
        del _orig_trans_58856930
        del _captureCollector_58856930
        del _wasBuffering_58856930
        # 
        _v = VFFSL(SL,"loopOverFieldInBasisWithVectorsAndInnerContent",False)(VFFSL(SL,"parent.reducedField",True), VFFSL(SL,"homeBasis",True), VFFSL(SL,"setOfVectorsToLoopOver",True),
                                                 VFFSL(SL,"loopContents",True), indexOverrides = VFFSL(SL,"indexOverrides",True),
                                                 vectorsNotNeedingDefines = VFFSL(SL,"setOfVectorsToLoopOver",True))
        if _v is not None: write(_filter(_v, rawExpr='${loopOverFieldInBasisWithVectorsAndInnerContent($parent.reducedField, $homeBasis, $setOfVectorsToLoopOver,\n                                                 $loopContents, indexOverrides = $indexOverrides,\n                                                 vectorsNotNeedingDefines = $setOfVectorsToLoopOver)}')) # from line 175, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def initialiseCrossPropagationFunctionImplementation(self, **KWS):


        """
        Return code for initialising the boundary conditions of a cross-propagation integrator.
        
          This code both sets the boundary conditions and copies in the first values for the
          dependencies into the local dependency arrays.
        """

        ## CHEETAH: generated from @def initialiseCrossPropagationFunctionImplementation at line 182, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''void _''')
        _v = VFFSL(SL,"name",True) # '${name}' on line 190, col 7
        if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 190, col 7.
        write('''_initialise_cross_propagation()
{
''')
        positiveIndexOverride = '0'
        basis = VFFSL(SL,"parent.operatorBasis",True)
        propDimRep = VFN(VFN(VFFSL(SL,"parent.field",True),"dimensionWithName",False)(VFFSL(SL,"propagationDimension",True)),"inBasis",False)(basis)
        negativeIndexOverride = ''.join(['(',str(VFFSL(SL,"propDimRep.globalLattice",True)),' - 1)'])
        # 
        combinedLoopVectorMap = VFN(VFFSL(SL,"integrationVectorMap",True),"copy",False)()
        combinedLoopVectorMap.update(VFFSL(SL,"dependencyMap",True))
        # 
        vectorsNeedingTransforms = set(combinedLoopVectorMap.values())
        boundaryConditionDependencies = VFN(VFN(VFFSL(SL,"parent",True),"codeBlocks",True)['boundaryCondition'],"dependencies",True)
        vectorsNeedingTransforms.update(boundaryConditionDependencies)
        write('''  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(vectorsNeedingTransforms, basis) # '${transformVectorsToBasis(vectorsNeedingTransforms, basis), autoIndent=True}' on line 203, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis(vectorsNeedingTransforms, basis), autoIndent=True}')) # from line 203, col 3.
        write('''  
''')
        if VFFSL(SL,"propagationDirection",True) == '+': # generated from line 205, col 3
            index = VFFSL(SL,"positiveIndexOverride",True)
        else: # generated from line 207, col 3
            index = VFFSL(SL,"negativeIndexOverride",True)
        write('''  real ''')
        _v = VFFSL(SL,"propagationDimension",True) # '$propagationDimension' on line 210, col 8
        if _v is not None: write(_filter(_v, rawExpr='$propagationDimension')) # from line 210, col 8.
        write(''' = ''')
        _v = VFFSL(SL,"propDimRep.arrayName",True) # '${propDimRep.arrayName}' on line 210, col 32
        if _v is not None: write(_filter(_v, rawExpr='${propDimRep.arrayName}')) # from line 210, col 32.
        write('''[''')
        _v = VFFSL(SL,"index",True) # '$index' on line 210, col 56
        if _v is not None: write(_filter(_v, rawExpr='$index')) # from line 210, col 56.
        write('''];
  
  // Copy the initial value of the cross-propagation integration vectors and dependencies into our local arrays
  {
    ''')
        _v = VFFSL(SL,"reducedFieldCopy",False)(combinedLoopVectorMap,
"""_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}];
""", positiveIndexOverride = VFFSL(SL,"positiveIndexOverride",True), negativeIndexOverride = VFFSL(SL,"negativeIndexOverride",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${reducedFieldCopy(combinedLoopVectorMap,\n"""_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}];\n""", positiveIndexOverride = $positiveIndexOverride, negativeIndexOverride = $negativeIndexOverride), autoIndent=True}')) # from line 214, col 5.
        for reducedVector in VFN(VFFSL(SL,"combinedLoopVectorMap",True),"keys",False)(): # generated from line 217, col 5
            if VFFSL(SL,"reducedVector.needsTransforms",True): # generated from line 218, col 7
                write('''      _''')
                _v = VFFSL(SL,"reducedVector.id",True) # '${reducedVector.id}' on line 219, col 8
                if _v is not None: write(_filter(_v, rawExpr='${reducedVector.id}')) # from line 219, col 8.
                write('''_basis = ''')
                _v = VFFSL(SL,"basisIndexForBasis",False)(VFN(VFFSL(SL,"reducedVector.field",True),"basisForBasis",False)(VFFSL(SL,"basis",True))) # '$basisIndexForBasis($reducedVector.field.basisForBasis($basis))' on line 219, col 36
                if _v is not None: write(_filter(_v, rawExpr='$basisIndexForBasis($reducedVector.field.basisForBasis($basis))')) # from line 219, col 36.
                write('''; 
''')
        write('''  }
  
''')
        # 
        write('''  // Set the boundary condition
  {
    ''')
        _v = VFN(VFN(VFFSL(SL,"parent",True),"codeBlocks",True)['boundaryCondition'],"loop",False)(self.boundaryConditionCode) # "${parent.codeBlocks['boundaryCondition'].loop(self.boundaryConditionCode), autoIndent=True}" on line 227, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${parent.codeBlocks['boundaryCondition'].loop(self.boundaryConditionCode), autoIndent=True}")) # from line 227, col 5.
        write('''  }

  // Copy the initial value of the integration vectors back into their main arrays
  {
    ''')
        _v = VFFSL(SL,"reducedFieldCopy",False)(VFFSL(SL,"integrationVectorMap",True),
"""_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}];
""", positiveIndexOverride = VFFSL(SL,"positiveIndexOverride",True), negativeIndexOverride = VFFSL(SL,"negativeIndexOverride",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${reducedFieldCopy($integrationVectorMap,\n"""_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex}];\n""", positiveIndexOverride = $positiveIndexOverride, negativeIndexOverride = $negativeIndexOverride), autoIndent=True}')) # from line 232, col 5.
        write('''  }
  
}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def boundaryConditionCode(self, codeString, **KWS):



        ## CHEETAH: generated from @def boundaryConditionCode($codeString) at line 241, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''// ********** Boundary condition code ***********
''')
        _v = VFFSL(SL,"codeString",True) # '${codeString}' on line 244, col 1
        if _v is not None: write(_filter(_v, rawExpr='${codeString}')) # from line 244, col 1.
        write('''// **********************************************
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def copyResultIntoIntegrationArrays(self, **KWS):


        """
        Returns code to copy the result of our cross-propagation step back into the original arrays
          for the integation vectors.
        """

        ## CHEETAH: generated from @def copyResultIntoIntegrationArrays at line 250, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''// Copy the result back into the original array.
{
  ''')
        _v = VFFSL(SL,"reducedFieldCopy",False)(VFFSL(SL,"integrationVectorMap",True), 
"""
_active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents] = \
  _active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}];
""")
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${reducedFieldCopy($integrationVectorMap, \n"""\n_active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents] = \\\n  _active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}];\n"""), autoIndent=True}')) # from line 258, col 3.
        write('''}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def updateDependenciesForNextStep(self, **KWS):


        """
        Return code to update our dependencies vectors from the originals for the next step.
        """

        ## CHEETAH: generated from @def updateDependenciesForNextStep at line 268, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''// Update the dependencies for the next step
{
  ''')
        _v = VFFSL(SL,"reducedFieldCopy",False)(VFFSL(SL,"dependencyMap",True),
"""
_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = \
  _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents];
""")
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${reducedFieldCopy($dependencyMap,\n"""\n_active_${reducedVector.id}[_${reducedVector.id}_index_pointer + ${componentIndex}] = \\\n  _active_${vector.id}[_${vector.id}_index_pointer + ${componentIndex} + ${skipSize} * _${vector.id}_ncomponents];\n"""), autoIndent=True}')) # from line 275, col 3.
        write('''}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # FixedStep.tmpl
        # 
        # Created by Graham Dennis on 2007-10-20.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''










''')
        #  ---- Cross-propagation methods ----
        write('''








''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_FixedStep = 'writeBody'

## END CLASS DEFINITION

if not hasattr(FixedStep, '_initCheetahAttributes'):
    templateAPIClass = getattr(FixedStep,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(FixedStep)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=FixedStep()).run()


