#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Segments.Integrators._Integrator import _Integrator
from xpdeint.CallOnceGuards import callOncePerInstanceGuard

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'Integrator.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class Integrator(_Integrator):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(Integrator, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: segment $segmentNumber ($stepper.name Integrator) at line 27, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''segment ''')
        _v = VFFSL(SL,"segmentNumber",True) # '$segmentNumber' on line 27, col 27
        if _v is not None: write(_filter(_v, rawExpr='$segmentNumber')) # from line 27, col 27.
        write(''' (''')
        _v = VFFSL(SL,"stepper.name",True) # '$stepper.name' on line 27, col 43
        if _v is not None: write(_filter(_v, rawExpr='$stepper.name')) # from line 27, col 43.
        write(''' Integrator)''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def globals(self, **KWS):



        ## CHEETAH: generated from @def globals at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(Integrator, self).globals()
        if _v is not None: write(_filter(_v))
        # 
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 33, col 3
            #  Loop over the variables that need to be created
            for arrayName in VFFSL(SL,"extraIntegrationArrayNames",True): # generated from line 35, col 5
                _v = VFFSL(SL,"vector.type",True) # '${vector.type}' on line 36, col 1
                if _v is not None: write(_filter(_v, rawExpr='${vector.type}')) # from line 36, col 1.
                write('''* _''')
                _v = VFFSL(SL,"name",True) # '${name}' on line 36, col 18
                if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 36, col 18.
                write('''_''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 36, col 26
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 36, col 26.
                write('''_''')
                _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 36, col 39
                if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 36, col 39.
                write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def deltaAFunctionBody(self, function, **KWS):



        ## CHEETAH: generated from @def deltaAFunctionBody($function) at line 42, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  First evaluate any computed vector that any of our operators may depend on
        _v = VFFSL(SL,"evaluateComputedVectors",False)(VFFSL(SL,"dynamicVectorsNeedingPrecalculationForOperatorContainers",False)(VFFSL(SL,"intraStepOperatorContainers",True)), static = False) # '${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($intraStepOperatorContainers), static = False)}' on line 45, col 1
        if _v is not None: write(_filter(_v, rawExpr='${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($intraStepOperatorContainers), static = False)}')) # from line 45, col 1.
        # 
        #  Then loop over operators that come before the delta A operators in the order in which
        #  they appear in the xmds script.
        # 
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainers",True): # generated from line 50, col 3
            write('''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluatePreDeltaAOperators",False)(parentFunction = function) # '${operatorContainer.evaluatePreDeltaAOperators(parentFunction = function)}' on line 52, col 1
            if _v is not None: write(_filter(_v, rawExpr='${operatorContainer.evaluatePreDeltaAOperators(parentFunction = function)}')) # from line 52, col 1.
        # 
        #  Now loop over delta A operators
        #  See the comment in _Integrator about why this needs to be done in
        #  this particular order
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainersInFieldDescendingOrder",True): # generated from line 58, col 3
            #  Blank line for formatting
            write('''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluateDeltaAOperator",False)(parentFunction = function) # '${operatorContainer.evaluateDeltaAOperator(parentFunction = function)}' on line 61, col 1
            if _v is not None: write(_filter(_v, rawExpr='${operatorContainer.evaluateDeltaAOperator(parentFunction = function)}')) # from line 61, col 1.
        # 
        #  Lastly, loop over the operators that come after the delta a operators in the order in
        #  which they appear in the xmds script.
        # 
        for operatorContainer in VFFSL(SL,"intraStepOperatorContainers",True): # generated from line 67, col 3
            #  Blank line for formatting
            write('''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluatePostDeltaAOperators",False)(parentFunction = function) # '${operatorContainer.evaluatePostDeltaAOperators(parentFunction = function)}' on line 70, col 1
            if _v is not None: write(_filter(_v, rawExpr='${operatorContainer.evaluatePostDeltaAOperators(parentFunction = function)}')) # from line 70, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def preSingleStep(self, **KWS):



        ## CHEETAH: generated from @def preSingleStep at line 75, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"evaluateComputedVectors",False)(VFFSL(SL,"dynamicVectorsNeedingPrecalculationForOperatorContainers",False)(VFFSL(SL,"stepStartOperatorContainers",True))) # '${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($stepStartOperatorContainers))}' on line 77, col 1
        if _v is not None: write(_filter(_v, rawExpr='${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($stepStartOperatorContainers))}')) # from line 77, col 1.
        # 
        for operatorContainer in VFFSL(SL,"stepStartOperatorContainers",True): # generated from line 79, col 3
            write('''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluateOperators",False)(_step = '_step') # "${operatorContainer.evaluateOperators(_step = '_step')}" on line 81, col 1
            if _v is not None: write(_filter(_v, rawExpr="${operatorContainer.evaluateOperators(_step = '_step')}")) # from line 81, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def postSingleStep(self, **KWS):



        ## CHEETAH: generated from @def postSingleStep at line 86, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        featureOrdering = ['HaltNonFinite']
        # 
        _v = VFFSL(SL,"insertCodeForFeatures",False)('postSingleStep', featureOrdering) # "${insertCodeForFeatures('postSingleStep', featureOrdering)}" on line 90, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeatures('postSingleStep', featureOrdering)}")) # from line 90, col 1.
        # 
        _v = VFFSL(SL,"evaluateComputedVectors",False)(VFFSL(SL,"dynamicVectorsNeedingPrecalculationForOperatorContainers",False)(VFFSL(SL,"stepEndOperatorContainers",True))) # '${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($stepEndOperatorContainers))}' on line 92, col 1
        if _v is not None: write(_filter(_v, rawExpr='${evaluateComputedVectors($dynamicVectorsNeedingPrecalculationForOperatorContainers($stepEndOperatorContainers))}')) # from line 92, col 1.
        # 
        for operatorContainer in VFFSL(SL,"stepEndOperatorContainers",True): # generated from line 94, col 3
            write('''
''')
            _v = VFN(VFFSL(SL,"operatorContainer",True),"evaluateOperators",False)(_step = '_step') # "${operatorContainer.evaluateOperators(_step = '_step')}" on line 96, col 1
            if _v is not None: write(_filter(_v, rawExpr="${operatorContainer.evaluateOperators(_step = '_step')}")) # from line 96, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    @callOncePerInstanceGuard
    def allocate(self, **KWS):


        """
        Allocate additional arrays needed for the integrator
        
        This is a call once-per-instance function because we may want to do the initialisation
        (and clean-up) for this segment in a parent segment for efficiency reasons (if, for
        example we are looping over this segment, or we are running multiple paths).
        """

        ## CHEETAH: generated from @def allocate at line 102, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(Integrator, self).allocate()
        if _v is not None: write(_filter(_v))
        # 
        #  Loop over the vectors creating the arrays
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 114, col 3
            #  Loop over the variables that need to be created
            for arrayName in VFFSL(SL,"extraIntegrationArrayNames",True): # generated from line 116, col 5
                write('''_''')
                _v = VFFSL(SL,"name",True) # '${name}' on line 117, col 2
                if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 117, col 2.
                write('''_''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 117, col 10
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 117, col 10.
                write('''_''')
                _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 117, col 23
                if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 117, col 23.
                write(''' = ''')
                write('''(''')
                _v = VFFSL(SL,"vector.type",True) # '${vector.type}' on line 118, col 2
                if _v is not None: write(_filter(_v, rawExpr='${vector.type}')) # from line 118, col 2.
                write('''*) xmds_malloc(sizeof(''')
                _v = VFFSL(SL,"vector.type",True) # '${vector.type}' on line 118, col 38
                if _v is not None: write(_filter(_v, rawExpr='${vector.type}')) # from line 118, col 38.
                write(''') * MAX(''')
                _v = VFFSL(SL,"vector.allocSize",True) # '${vector.allocSize}' on line 118, col 60
                if _v is not None: write(_filter(_v, rawExpr='${vector.allocSize}')) # from line 118, col 60.
                write(''',1));
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    @callOncePerInstanceGuard
    def free(self, **KWS):



        ## CHEETAH: generated from @def free at line 125, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(Integrator, self).free()
        if _v is not None: write(_filter(_v))
        # 
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 129, col 3
            for arrayName in VFFSL(SL,"extraIntegrationArrayNames",True): # generated from line 130, col 5
                write('''xmds_free(_''')
                _v = VFFSL(SL,"name",True) # '${name}' on line 131, col 12
                if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 131, col 12.
                write('''_''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 131, col 20
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 131, col 20.
                write('''_''')
                _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 131, col 33
                if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 131, col 33.
                write(''');
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def localInitialise(self, **KWS):


        """
        Because the initialisation for the integrator could be in a different function,
        we need to set up pointers in the integrator to the appropriate arrays.
        """

        ## CHEETAH: generated from @def localInitialise at line 137, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 143, col 3
            #  Loop over the variables that need to be created
            for arrayName in VFFSL(SL,"extraIntegrationArrayNames",True): # generated from line 145, col 5
                _v = VFFSL(SL,"vector.type",True) # '${vector.type}' on line 146, col 1
                if _v is not None: write(_filter(_v, rawExpr='${vector.type}')) # from line 146, col 1.
                write('''* _''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 146, col 18
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 146, col 18.
                write('''_''')
                _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 146, col 31
                if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 146, col 31.
                write(''' = _''')
                _v = VFFSL(SL,"name",True) # '${name}' on line 146, col 47
                if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 146, col 47.
                write('''_''')
                _v = VFFSL(SL,"arrayName",True) # '${arrayName}' on line 146, col 55
                if _v is not None: write(_filter(_v, rawExpr='${arrayName}')) # from line 146, col 55.
                write('''_''')
                _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 146, col 68
                if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 146, col 68.
                write(''';
''')
        write('''
''')
        _v = VFFSL(SL,"stepper.localInitialise",True) # '${stepper.localInitialise}' on line 150, col 1
        if _v is not None: write(_filter(_v, rawExpr='${stepper.localInitialise}')) # from line 150, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def localFinalise(self, **KWS):


        """
        Because the finalisation for the integrator could be in a different function,
        we need to be able to insert code at the end of the integrator as well.
        """

        ## CHEETAH: generated from @def localFinalise at line 154, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''_SEGMENT''')
        _v = VFFSL(SL,"segmentNumber",True) # '${segmentNumber}' on line 160, col 9
        if _v is not None: write(_filter(_v, rawExpr='${segmentNumber}')) # from line 160, col 9.
        write('''_END:;
''')
        _v = VFFSL(SL,"stepper.localFinalise",True) # '${stepper.localFinalise}' on line 161, col 1
        if _v is not None: write(_filter(_v, rawExpr='${stepper.localFinalise}')) # from line 161, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def earlyTerminationCode(self, **KWS):


        """
        This method writes code that should be executed if the integrator needs
        to be terminated early
        """

        ## CHEETAH: generated from @def earlyTerminationCode at line 165, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        for mg, sampleCount in zip(VFFSL(SL,"momentGroups",True), VFFSL(SL,"samples",True)): # generated from line 171, col 3
            if not VFFSL(SL,"sampleCount",True): # generated from line 172, col 5
                continue
            # 
            for dim in filter(lambda x: not x.transverse, mg.outputField.dimensions): # generated from line 176, col 5
                dimRep = dim.inBasis(mg.outputBasis)
                write('''if (''')
                _v = VFFSL(SL,"dimRep.prefix",True) # '${dimRep.prefix}' on line 178, col 5
                if _v is not None: write(_filter(_v, rawExpr='${dimRep.prefix}')) # from line 178, col 5.
                write('''_index_''')
                _v = VFFSL(SL,"dimRep.name",True) # '${dimRep.name}' on line 178, col 28
                if _v is not None: write(_filter(_v, rawExpr='${dimRep.name}')) # from line 178, col 28.
                write(''' < ''')
                _v = VFFSL(SL,"dimRep.globalLattice",True) # '${dimRep.globalLattice}' on line 178, col 45
                if _v is not None: write(_filter(_v, rawExpr='${dimRep.globalLattice}')) # from line 178, col 45.
                write(''')
  _''')
                _v = VFFSL(SL,"mg.name",True) # '${mg.name}' on line 179, col 4
                if _v is not None: write(_filter(_v, rawExpr='${mg.name}')) # from line 179, col 4.
                write('''_sample();
''')
        write('''
goto _SEGMENT''')
        _v = VFFSL(SL,"segmentNumber",True) # '${segmentNumber}' on line 183, col 14
        if _v is not None: write(_filter(_v, rawExpr='${segmentNumber}')) # from line 183, col 14.
        write('''_END;
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # Integrator.tmpl
        # 
        # Created by Graham Dennis on 2007-10-20.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''









''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_Integrator = 'writeBody'

## END CLASS DEFINITION

if not hasattr(Integrator, '_initCheetahAttributes'):
    templateAPIClass = getattr(Integrator,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(Integrator)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=Integrator()).run()


