#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Segments.Integrators._Stepper import _Stepper

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'MMStepper.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class MMStepper(_Stepper):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(MMStepper, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def name(self, **KWS):



        ## Generated from @def name: MM at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''MM''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def singleIntegrationStep(self, function, **KWS):



        ## CHEETAH: generated from @def singleIntegrationStep($function) at line 37, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''// Start of single step
''')
        arguments = {'_step': '_step', VFFSL(SL,"propagationDimension",True): VFFSL(SL,"propagationDimension",True)}
        write('''
''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis)}' on line 42, col 1
        if _v is not None: write(_filter(_v, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis)}')) # from line 42, col 1.
        write('''
if (_istep == 0) 
{
  // a_k = a
  ''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_akfield') # "${copyVectors($integrationVectors, '_akfield'), autoIndent=True}" on line 47, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${copyVectors($integrationVectors, '_akfield'), autoIndent=True}")) # from line 47, col 3.
        write('''  
  // active vector = a_i
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_aifield') # "${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}" on line 50, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}")) # from line 50, col 3.
        write('''  
  // a_i = a
  ''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_aifield') # "${copyVectors($integrationVectors, '_aifield'), autoIndent=True}" on line 53, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${copyVectors($integrationVectors, '_aifield'), autoIndent=True}")) # from line 53, col 3.
        write('''  
  // a_i = G[a_i, t]
  ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, parentFunction = function) # "${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}" on line 56, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}")) # from line 56, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 59, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 59, col 3.
        write('''  
  // active vector = a
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active') # "${assignVectorPointers($integrationVectors, '_active'), autoIndent=True}" on line 62, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active'), autoIndent=True}")) # from line 62, col 3.
        write('''  
  // a = a + G[a_i, t]
  ''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectors",True), 
"""_${vector.id}[$index] += _aifield_${vector.id}[$index];
""", basis = VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${loopOverVectorsWithInnerContentTemplate($integrationVectors, \n"""_${vector.id}[$index] += _aifield_${vector.id}[$index];\n""", basis = $homeBasis), autoIndent=True}')) # from line 65, col 3.
        write('''  
  ''')
        _v = VFFSL(SL,"callFunction",False)('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function) # "${callFunction('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function), autoIndent=True}" on line 69, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function), autoIndent=True}")) # from line 69, col 3.
        write('''
  
  // ipEvolve a +1
  ''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction = function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIdent=True}" on line 72, col 3
        if _v is not None: write(_filter(_v, autoIdent=True, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIdent=True}")) # from line 72, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 75, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 75, col 3.
        write('''  
  ''')
        _v = VFFSL(SL,"propagationDimension",True) # '${propagationDimension}' on line 77, col 3
        if _v is not None: write(_filter(_v, rawExpr='${propagationDimension}')) # from line 77, col 3.
        write(''' += _step;
  
} // For all steps past the first:
else 
{
  // active vector = a_k
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_akfield') # "${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}" on line 83, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}")) # from line 83, col 3.
        write('''  
  // ipEvolve a_k +1
  ''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction = function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}" on line 86, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}")) # from line 86, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 89, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 89, col 3.
        write('''  
  // active vector = a_i
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_aifield') # "${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}" on line 92, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}")) # from line 92, col 3.
        write('''  
  // a_i = a
  ''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_aifield') # "${copyVectors($integrationVectors, '_aifield'), autoIndent=True}" on line 95, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${copyVectors($integrationVectors, '_aifield'), autoIndent=True}")) # from line 95, col 3.
        write('''  
  // a_i = G[a_i, t]
  ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, parentFunction = function) # "${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}" on line 98, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}")) # from line 98, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 101, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 101, col 3.
        write('''  
  // active vector = a_k
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_akfield') # "${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}" on line 104, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}")) # from line 104, col 3.
        write('''  
  // a_k = a_k + 2*a_i
  ''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectors",True), 
"""_akfield_${vector.id}[$index] = _akfield_${vector.id}[$index] + 2*_aifield_${vector.id}[$index];
""", basis = VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${loopOverVectorsWithInnerContentTemplate($integrationVectors, \n"""_akfield_${vector.id}[$index] = _akfield_${vector.id}[$index] + 2*_aifield_${vector.id}[$index];\n""", basis = $homeBasis), autoIndent=True}')) # from line 107, col 3.
        write('''  
  ''')
        _v = VFFSL(SL,"callFunction",False)('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function) # "${callFunction('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function), autoIndent=True}" on line 111, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('nonconstantIPFields', arguments, _exponent = 1, _arrayIndex = 0, parentFunction = function), autoIndent=True}")) # from line 111, col 3.
        write('''
  
  // ipEvolve a_k +1
  ''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction = function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}" on line 114, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}")) # from line 114, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 117, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 117, col 3.
        write('''  
  // a = a_k, a_k = a
  ''')
        _v = VFFSL(SL,"swapVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_akfield') # "${swapVectorPointers($integrationVectors, '_akfield'), autoIndent=True}" on line 120, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${swapVectorPointers($integrationVectors, '_akfield'), autoIndent=True}")) # from line 120, col 3.
        write('''  
  ''')
        _v = VFFSL(SL,"propagationDimension",True) # '${propagationDimension}' on line 122, col 3
        if _v is not None: write(_filter(_v, rawExpr='${propagationDimension}')) # from line 122, col 3.
        write(''' += _step;
  
}

if (_istep == (''')
        _v = VFFSL(SL,"getVar",False)('integrator.maxIntegrationStepsVar', VFFSL(SL,"integrator.stepCount",True)) # "$getVar('integrator.maxIntegrationStepsVar', $integrator.stepCount)" on line 126, col 16
        if _v is not None: write(_filter(_v, rawExpr="$getVar('integrator.maxIntegrationStepsVar', $integrator.stepCount)")) # from line 126, col 16.
        write(''' - 1)) {
  // active vector = a_k
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_akfield') # "${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}" on line 128, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_akfield'), autoIndent=True}")) # from line 128, col 3.
        write('''  
  // ipEvolve a_k +1
  ''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction = function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}" on line 131, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction = function), autoIndent=True}")) # from line 131, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 134, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 134, col 3.
        write('''  
  // active vector = a_i
  ''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active', '_aifield') # "${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}" on line 137, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${assignVectorPointers($integrationVectors, '_active', '_aifield'), autoIndent=True}")) # from line 137, col 3.
        write('''  
  // a_i = a
  ''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_aifield') # "${copyVectors($integrationVectors, '_aifield'), autoIndent=True}" on line 140, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${copyVectors($integrationVectors, '_aifield'), autoIndent=True}")) # from line 140, col 3.
        write('''  
  // a_i = G[a_i, t]
  ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, parentFunction = function) # "${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}" on line 143, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('deltaA', arguments, parentFunction = function), autoIndent=True}")) # from line 143, col 3.
        write('''
  
  // transformToHomeSpace()
  ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 146, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 146, col 3.
        write('''  
  // a = 0.5*(a + a_k + G[a_i, t])
  ''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectors",True), 
"""_${vector.id}[$index] = 0.5*(_${vector.id}[$index] + _akfield_${vector.id}[$index] + _aifield_${vector.id}[$index]);
""", basis = VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${loopOverVectorsWithInnerContentTemplate($integrationVectors, \n"""_${vector.id}[$index] = 0.5*(_${vector.id}[$index] + _akfield_${vector.id}[$index] + _aifield_${vector.id}[$index]);\n""", basis = $homeBasis), autoIndent=True}')) # from line 149, col 3.
        write('''  
  if ((''')
        _v = VFFSL(SL,"getVar",False)('integrator.maxIntegrationStepsVar', VFFSL(SL,"integrator.stepCount",True)) # "$getVar('integrator.maxIntegrationStepsVar', $integrator.stepCount)" on line 153, col 8
        if _v is not None: write(_filter(_v, rawExpr="$getVar('integrator.maxIntegrationStepsVar', $integrator.stepCount)")) # from line 153, col 8.
        write(''' % 2) == 0) {
    // Odd number of vector swaps, need to swap back and memcpy
    // so that the original vectors are deallocated correctly
    ''')
        _v = VFFSL(SL,"swapVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_akfield') # "${swapVectorPointers($integrationVectors, '_akfield'), autoIndent=True}" on line 156, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${swapVectorPointers($integrationVectors, '_akfield'), autoIndent=True}")) # from line 156, col 5.
        write('''    ''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), None, '_akfield') # "${copyVectors($integrationVectors, None, '_akfield'), autoIndent=True}" on line 157, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${copyVectors($integrationVectors, None, '_akfield'), autoIndent=True}")) # from line 157, col 5.
        write('''  }
  
}

// To ensure correct sampling, set active dimension to vector
''')
        _v = VFFSL(SL,"assignVectorPointers",False)(VFFSL(SL,"integrationVectors",True), '_active') # "${assignVectorPointers($integrationVectors, '_active')}" on line 163, col 1
        if _v is not None: write(_filter(_v, rawExpr="${assignVectorPointers($integrationVectors, '_active')}")) # from line 163, col 1.
        write('''
// End of single step
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # MMStepper.tmpl
        # 
        # Created by Damien Beard on 2013-08-07, with code adapted from Graham Dennis.
        # Last modified by Sean Wild on 2013-08-02.
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''// Start of stepper



''')
        # 
        #   Single integration step (MM)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    ipPropagationStepFractions = ['1']

    nonconstantIPFields = 1

    extraIntegrationArrayNames = ['akfield', 'aifield']

    isCrossCapable = False

    integrationOrder = 2.0

    _mainCheetahMethod_for_MMStepper = 'writeBody'

## END CLASS DEFINITION

if not hasattr(MMStepper, '_initCheetahAttributes'):
    templateAPIClass = getattr(MMStepper,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(MMStepper)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=MMStepper()).run()


