#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Segments.Integrators._Stepper import _Stepper

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'SICStepper.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SICStepper(_Stepper):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(SICStepper, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def name(self, **KWS):



        ## Generated from @def name: SIC at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''SIC''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def singleIntegrationStep(self, function, **KWS):



        ## CHEETAH: generated from @def singleIntegrationStep($function) at line 35, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        arguments = {'_step': '_step', VFFSL(SL,"propagationDimension",True): VFFSL(SL,"propagationDimension",True)}
        _v = VFFSL(SL,"callFunction",False)('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function) # "${callFunction('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function)}" on line 38, col 1
        if _v is not None: write(_filter(_v, rawExpr="${callFunction('nonconstantIPFields', arguments, _exponent = 1, parentFunction=function)}")) # from line 38, col 1.
        write('''

''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction=function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}" on line 40, col 1
        if _v is not None: write(_filter(_v, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}")) # from line 40, col 1.
        write('''

''')
        _v = VFFSL(SL,"propagationDimension",True) # '${propagationDimension}' on line 42, col 1
        if _v is not None: write(_filter(_v, rawExpr='${propagationDimension}')) # from line 42, col 1.
        write(''' += 0.5*_step;

''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis)}' on line 44, col 1
        if _v is not None: write(_filter(_v, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis)}')) # from line 44, col 1.
        write('''
''')
        _v = VFFSL(SL,"copyVectors",False)(VFFSL(SL,"integrationVectors",True), '_oldcopy') # "${copyVectors($integrationVectors, '_oldcopy')}" on line 46, col 1
        if _v is not None: write(_filter(_v, rawExpr="${copyVectors($integrationVectors, '_oldcopy')}")) # from line 46, col 1.
        write('''
''')
        for vector in VFFSL(SL,"integrationVectors",True): # generated from line 48, col 3
            write('''_active_''')
            _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 49, col 9
            if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 49, col 9.
            write(''' = _''')
            _v = VFFSL(SL,"vector.id",True) # '${vector.id}' on line 49, col 25
            if _v is not None: write(_filter(_v, rawExpr='${vector.id}')) # from line 49, col 25.
            write(''';
''')
        write('''
for (int _iteration = 0; _iteration < ''')
        _v = VFFSL(SL,"iterations",True) # '${iterations}' on line 52, col 39
        if _v is not None: write(_filter(_v, rawExpr='${iterations}')) # from line 52, col 39.
        write('''; _iteration++) {
  if (_iteration < ''')
        _v = VFFSL(SL,"iterations",True) # '${iterations}' on line 53, col 20
        if _v is not None: write(_filter(_v, rawExpr='${iterations}')) # from line 53, col 20.
        write(''' - 1) {
''')
        if VFFSL(SL,"integrator.leftOperatorContainer",True): # generated from line 54, col 3
            write('''    ''')
            _v = VFFSL(SL,"callFunction",False)('leftDeltaA', arguments, _step = '0.5*_step', parentFunction=function) # "${callFunction('leftDeltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}" on line 55, col 5
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('leftDeltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}")) # from line 55, col 5.
        if VFFSL(SL,"integrator.rightOperatorContainer",True): # generated from line 57, col 3
            write('''    ''')
            _v = VFFSL(SL,"callFunction",False)('rightDeltaA', arguments, _step = '0.5*_step', parentFunction=function) # "${callFunction('rightDeltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}" on line 58, col 5
            if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('rightDeltaA', arguments, _step = '0.5*_step', parentFunction=function), autoIndent=True}")) # from line 58, col 5.
        write('''  } else {
    ''')
        _v = VFFSL(SL,"callFunction",False)('deltaA', arguments, parentFunction=function) # "${callFunction('deltaA', arguments, parentFunction=function), autoIndent=True}" on line 61, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${callFunction('deltaA', arguments, parentFunction=function), autoIndent=True}")) # from line 61, col 5.
        write('''    
    ''')
        _v = VFFSL(SL,"transformVectorsToBasis",False)(VFFSL(SL,"integrationVectors",True), VFFSL(SL,"homeBasis",True)) # '${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}' on line 63, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${transformVectorsToBasis($integrationVectors, $homeBasis), autoIndent=True}')) # from line 63, col 5.
        write('''    
    ''')
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)(VFFSL(SL,"integrationVectors",True),
"""// a = oldcopy + a
_${vector.id}[$index] += _oldcopy_${vector.id}[$index];
""", basis=VFFSL(SL,"homeBasis",True))
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr='${loopOverVectorsWithInnerContentTemplate($integrationVectors,\n"""// a = oldcopy + a\n_${vector.id}[$index] += _oldcopy_${vector.id}[$index];\n""", basis=$homeBasis), autoIndent=True}')) # from line 65, col 5.
        write('''  }
  
}

''')
        _v = VFFSL(SL,"callFunction",False)('ipEvolve', arguments, _exponent = +1, parentFunction=function) # "${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}" on line 73, col 1
        if _v is not None: write(_filter(_v, rawExpr="${callFunction('ipEvolve', arguments, _exponent = +1, parentFunction=function)}")) # from line 73, col 1.
        write('''

''')
        _v = VFFSL(SL,"propagationDimension",True) # '${propagationDimension}' on line 75, col 1
        if _v is not None: write(_filter(_v, rawExpr='${propagationDimension}')) # from line 75, col 1.
        write(''' += 0.5*_step;

''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # SICStepper.tmpl
        # 
        # Created by Graham Dennis on 2008-08-06.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''

''')
        # 
        #   Single integration step (SIC)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    ipPropagationStepFractions = ['0.5']

    extraIntegrationArrayNames = ['oldcopy']

    isCrossCapable = False

    iterations = 3

    _mainCheetahMethod_for_SICStepper = 'writeBody'

## END CLASS DEFINITION

if not hasattr(SICStepper, '_initCheetahAttributes'):
    templateAPIClass = getattr(SICStepper,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SICStepper)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SICStepper()).run()


