#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Segments.SequenceSegment import SequenceSegment

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'TopLevelSequenceElement.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class TopLevelSequenceElement(SequenceSegment):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(TopLevelSequenceElement, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: segment $segmentNumber (Top level sequence) at line 32, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''segment ''')
        _v = VFFSL(SL,"segmentNumber",True) # '$segmentNumber' on line 32, col 27
        if _v is not None: write(_filter(_v, rawExpr='$segmentNumber')) # from line 32, col 27.
        write(''' (Top level sequence)''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def functionImplementations(self, **KWS):



        ## CHEETAH: generated from @def functionImplementations at line 34, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  Make this empty as the content of the top-level sequence will be written by
        #  a simulation driver
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def topLevelSequenceInnerContent(self, **KWS):



        ## CHEETAH: generated from @def topLevelSequenceInnerContent at line 41, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"propagationDimension",True) # '$propagationDimension' on line 43, col 1
        if _v is not None: write(_filter(_v, rawExpr='$propagationDimension')) # from line 43, col 1.
        write(''' = 0.0;
''')
        # 
        write('''
''')
        fieldsNotToInitialise = set()
        for momentGroup in VFFSL(SL,"momentGroups",True): # generated from line 47, col 3
            #  Initialise the raw vector
            #  There's an exception to this initialisation: If we're using the export_all_paths
            #  option with the multipath driver on this moment group we only want to initialise this moment group
            #  for the first path, as we're using an extra dimension to store the results for
            #  for every single path. We don't want the previous path's information be overwritten.
            #  Furthermore, since the extra dimension will be initialised on the first path, 
            #  that means that single initialisation has initialised all the paths.
            #  Finally, note that there an extra intialisation we have to take care of in this
            #  case in MultiPathDriver.tmpl.
            if momentGroup.export_all_paths: # generated from line 57, col 5
                write('''if (gPathID == 0) {
  ''')
                _v = VFN(VFN(VFFSL(SL,"momentGroup.rawVector",True),"functions",True)['initialise'],"call",False)() # "${momentGroup.rawVector.functions['initialise'].call()}" on line 59, col 3
                if _v is not None: write(_filter(_v, rawExpr="${momentGroup.rawVector.functions['initialise'].call()}")) # from line 59, col 3.
                write('''
}
''')
            else: # generated from line 61, col 5
                _v = VFN(VFN(VFFSL(SL,"momentGroup.rawVector",True),"functions",True)['initialise'],"call",False)() # "${momentGroup.rawVector.functions['initialise'].call()}" on line 62, col 1
                if _v is not None: write(_filter(_v, rawExpr="${momentGroup.rawVector.functions['initialise'].call()}")) # from line 62, col 1.
                write('''
''')
            #  Don't call the initialise method as that will cause
            #  its aliases to be initialised, which is bad.
            fieldsNotToInitialise.add(momentGroup.outputField)
        # 
        vectorsToInitialise = set()
        for field in [f for f in VFFSL(SL,"fields",True) if f not in fieldsNotToInitialise]: # generated from line 70, col 3
            vectorsToInitialise.update([v for v in field.managedVectors if not (v.isComputed or v.isNoise)])
        # 
        for vector in self.evaluationOrderForVectors(vectorsToInitialise, static = True): # generated from line 74, col 3
            if vector.isComputed: # generated from line 75, col 5
                #  Computed vectors were explicitly removed from the set of vectors that need
                #  initialisation. The only way we can get one now is if one of the other vectors depends on this
                #  vector. In this case, we must provide the information the other vector is requiring. To do this,
                #  we must evaluate the vector, not initialise it.
                _v = VFN(VFN(VFFSL(SL,"vector",True),"functions",True)['evaluate'],"call",False)() # "${vector.functions['evaluate'].call()}" on line 80, col 1
                if _v is not None: write(_filter(_v, rawExpr="${vector.functions['evaluate'].call()}")) # from line 80, col 1.
                write('''
''')
            else: # generated from line 81, col 5
                _v = VFFSL(SL,"vector.initialise",True) # '${vector.initialise}' on line 82, col 1
                if _v is not None: write(_filter(_v, rawExpr='${vector.initialise}')) # from line 82, col 1.
        # 
        for momentGroup in VFFSL(SL,"momentGroups",True): # generated from line 86, col 3
            #  We only need to set the sample index for the propagation dimension
            #  and only if this moment group has the propagation dimension as one
            #  of its dimensions
            if not VFN(VFFSL(SL,"momentGroup.outputField",True),"hasDimensionName",False)(VFFSL(SL,"propagationDimension",True)): # generated from line 90, col 5
                continue
            write('''_''')
            _v = VFFSL(SL,"momentGroup.outputField.id",True) # '${momentGroup.outputField.id}' on line 93, col 2
            if _v is not None: write(_filter(_v, rawExpr='${momentGroup.outputField.id}')) # from line 93, col 2.
            write('''_index_''')
            _v = VFFSL(SL,"propagationDimension",True) # '${propagationDimension}' on line 93, col 38
            if _v is not None: write(_filter(_v, rawExpr='${propagationDimension}')) # from line 93, col 38.
            write(''' = 0;
''')
        # 
        for momentGroup in filter(lambda x: x.requiresInitialSample, VFFSL(SL,"momentGroups",True)): # generated from line 96, col 3
            write('''_mg''')
            _v = VFFSL(SL,"momentGroup.number",True) # '${momentGroup.number}' on line 97, col 4
            if _v is not None: write(_filter(_v, rawExpr='${momentGroup.number}')) # from line 97, col 4.
            write('''_sample();
''')
        # 
        _v = VFFSL(SL,"segmentFunctionBody",False)(function=None) # '${segmentFunctionBody(function=None)}' on line 100, col 1
        if _v is not None: write(_filter(_v, rawExpr='${segmentFunctionBody(function=None)}')) # from line 100, col 1.
        # 
        write('''
''')
        for momentGroup in VFFSL(SL,"momentGroups",True): # generated from line 103, col 3
            write('''_mg''')
            _v = VFFSL(SL,"momentGroup.number",True) # '${momentGroup.number}' on line 104, col 4
            if _v is not None: write(_filter(_v, rawExpr='${momentGroup.number}')) # from line 104, col 4.
            write('''_process();
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # TopLevelSequenceElement.tmpl
        # 
        # Created by Graham Dennis on 2007-08-27.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''
''')
        assert VFFSL(SL,"segmentNumber",True) == 0
        write('''
''')
        # 
        #   Description of template
        write('''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    globalNameSpaceName = "topLevelSequence"

    _mainCheetahMethod_for_TopLevelSequenceElement = 'writeBody'

## END CLASS DEFINITION

if not hasattr(TopLevelSequenceElement, '_initCheetahAttributes'):
    templateAPIClass = getattr(TopLevelSequenceElement,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(TopLevelSequenceElement)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=TopLevelSequenceElement()).run()


