#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.ScriptElement import ScriptElement

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'Simulation.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class Simulation(ScriptElement):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(Simulation, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def logFunctionInnerContent(self, **KWS):



        ## CHEETAH: generated from @def logFunctionInnerContent at line 212, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write('''if (logLevel & (_ERROR_LOG_LEVEL | _WARNING_LOG_LEVEL)) \\
    printf("%s:%i: ", __FILE__, __LINE__); \\
printf(__VA_ARGS__); \\
fflush(stdout); \\
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # Simulation.tmpl
        # 
        # Created by Graham Dennis on 2007-08-23.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        # 
        # 
        # 
        #  First check we have at least Cheetah version 2.0.1
        if __CHEETAH_versionTuple__ < (2, 0, 1, 'final', 0): # generated from line 31, col 1
            raise AssertionError("xmds2 requires at least Cheetah version "
                               "2.0.1. You currently have %s." % __CHEETAH_version__)
        # 
        # 
        #  Base simulation template
        write('''// ********************************************************
// simulation logging

#define _SAMPLE_LOG_LEVEL             (1 << 0)
#define _SEGMENT_LOG_LEVEL            (1 << 1)
#define _PATH_LOG_LEVEL               (1 << 2)
#define _SIMULATION_LOG_LEVEL         (1 << 3)
#define _WARNING_LOG_LEVEL            (1 << 4)
#define _ERROR_LOG_LEVEL              (1 << 5)
#define _NO_ERROR_TERMINATE_LOG_LEVEL (1 << 6)
#define _ALL_LOG_LEVELS        _SAMPLE_LOG_LEVEL|_SEGMENT_LOG_LEVEL|_PATH_LOG_LEVEL|_SIMULATION_LOG_LEVEL|_WARNING_LOG_LEVEL|_ERROR_LOG_LEVEL|_NO_ERROR_TERMINATE_LOG_LEVEL
#define _LOG_LEVELS_BEING_LOGGED (''')
        _v = VFN(VFFSL(SL,"features",True)['Driver'],"logLevelsBeingLogged",True) # "${features['Driver'].logLevelsBeingLogged}" on line 49, col 35
        if _v is not None: write(_filter(_v, rawExpr="${features['Driver'].logLevelsBeingLogged}")) # from line 49, col 35.
        write(''')

#define real Re
#define imag Im

#include <complex>

#undef real
#undef imag


#include <stdio.h>

''')
        featureOrdering = ['Driver']
        write('''#define _LOG(logLevel, ...) \\
  do { \\
    if (logLevel & _LOG_LEVELS_BEING_LOGGED) { \\
''')
        dict = {'extraIndent': 0}
        write('''      ''')
        _v = VFFSL(SL,"insertCodeForFeatures",False)('logFunctionBegin', VFFSL(SL,"featureOrdering",True), VFFSL(SL,"dict",True)) # "${insertCodeForFeatures('logFunctionBegin', $featureOrdering, $dict), autoIndent=True}" on line 67, col 7
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${insertCodeForFeatures('logFunctionBegin', $featureOrdering, $dict), autoIndent=True}")) # from line 67, col 7.
        extraIndent = dict['extraIndent']
        write('''      ''')
        _v = VFFSL(SL,"logFunctionInnerContent",True) # '${logFunctionInnerContent, autoIndent=True, extraIndent=extraIndent}' on line 69, col 7
        if _v is not None: write(_filter(_v, autoIndent=True, extraIndent=extraIndent, rawExpr='${logFunctionInnerContent, autoIndent=True, extraIndent=extraIndent}')) # from line 69, col 7.
        write('''      ''')
        _v = VFFSL(SL,"insertCodeForFeaturesInReverseOrder",False)('logFunctionEnd', VFFSL(SL,"featureOrdering",True), VFFSL(SL,"dict",True)) # "${insertCodeForFeaturesInReverseOrder('logFunctionEnd', $featureOrdering, $dict), autoIndent=True}" on line 70, col 7
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr="${insertCodeForFeaturesInReverseOrder('logFunctionEnd', $featureOrdering, $dict), autoIndent=True}")) # from line 70, col 7.
        write("""      if (logLevel & (_ERROR_LOG_LEVEL | _NO_ERROR_TERMINATE_LOG_LEVEL)) \\
        exit(logLevel == _ERROR_LOG_LEVEL); \\
    } \\
  } while (0)

// ********************************************************
// simulation includes

#include <xpdeint_platform.h>
#include <cmath>
#include <string>
#include <cstring>
#include <fstream>
#include <sstream>
#include <cstdlib>

#if CFG_OSAPI == CFG_OSAPI_POSIX // These are POSIX headers (i.e. non-windows)
  #include <sys/time.h>
#endif // POSIX

#ifdef __APPLE__
  #include <Availability.h>
  #if __MAC_OS_X_VERSION_MIN_REQUIRED >= 1080
    #define OS_OBJECT_USE_OBJC 0 // Don't make dispatch and xpc objects Objective-C objects.
    #include <IOKit/pwr_mgt/IOPMLib.h> // To disable user idle sleep on Mountain Lion
  #endif
#endif

#include <time.h>
#include <list>
#include <vector>
#include <algorithm>

""")
        for child in VFFSL(SL,"children",True): # generated from line 104, col 1
            #  Prevent writing zero-length defines
            result = VFN(VFFSL(SL,"child",True),"implementationsForFunctionName",False)('includes')
            if VFFSL(SL,"result",True) and not VFN(VFFSL(SL,"result",True),"isspace",False)(): # generated from line 107, col 3
                _v = VFFSL(SL,"result",True) # '${result}' on line 108, col 1
                if _v is not None: write(_filter(_v, rawExpr='${result}')) # from line 108, col 1.
                write('''
''')
        write('''
''')
        realType = {'single': 'float', 'double': 'double'}[VFFSL(SL,"precision",True)]
        write('''typedef long integer;
typedef ''')
        _v = VFFSL(SL,"realType",True) # '${realType}' on line 115, col 9
        if _v is not None: write(_filter(_v, rawExpr='${realType}')) # from line 115, col 9.
        write(""" real;
typedef std::complex<real> XMDSComplexType;

#include <xpdeint.h>

#define complex XMDSComplexType

const complex i(0.0, 1.0);

using namespace std;

#if CFG_COMPILER == CFG_COMPILER_ICC
  //
  // Disable ICC's warning: label was declared but never referenced
  //
  #pragma warning ( disable : 177 )
#endif

inline void *xmds_malloc(size_t size);

// ********************************************************
// DEFINES
// ********************************************************
""")
        #  only loop over the elements that implement the defines function
        for child in VFFSL(SL,"children",True): # generated from line 139, col 1
            #  Prevent writing zero-length defines
            result = VFN(VFFSL(SL,"child",True),"implementationsForFunctionName",False)('defines')
            if result and not result.isspace(): # generated from line 142, col 3
                write('''
// ********************************************************
//   ''')
                _v = VFFSL(SL,"child.description",True) # '$child.description' on line 145, col 6
                if _v is not None: write(_filter(_v, rawExpr='$child.description')) # from line 145, col 6.
                write(''' defines
''')
                _v = VFFSL(SL,"result",True) # '$result' on line 146, col 1
                if _v is not None: write(_filter(_v, rawExpr='$result')) # from line 146, col 1.
        write('''

// ********************************************************
// GLOBALS
// ********************************************************

''')
        #  only loop over the elements that implement the globals function
        for child in VFFSL(SL,"children",True): # generated from line 156, col 1
            #  Prevent writing zero-length globals
            result = VFN(VFFSL(SL,"child",True),"implementationsForFunctionName",False)('globals')
            if result and not result.isspace(): # generated from line 159, col 3
                write('''
// ********************************************************
//   ''')
                _v = VFFSL(SL,"child.description",True) # '$child.description' on line 162, col 6
                if _v is not None: write(_filter(_v, rawExpr='$child.description')) # from line 162, col 6.
                write(''' globals
''')
                _v = VFFSL(SL,"result",True) # '$result' on line 163, col 1
                if _v is not None: write(_filter(_v, rawExpr='$result')) # from line 163, col 1.
        write('''

// ********************************************************
// FUNCTION PROTOTYPES
// ********************************************************
''')
        #  only loop over the elements that implement the prototypes function
        for child in VFFSL(SL,"children",True): # generated from line 172, col 1
            #  Prevent writing zero-length globals
            result = VFN(VFFSL(SL,"child",True),"implementationsForFunctionName",False)('functionPrototypes')
            if result and not result.isspace(): # generated from line 175, col 3
                write('''
// ********************************************************
//   ''')
                _v = VFFSL(SL,"child.description",True) # '$child.description' on line 178, col 6
                if _v is not None: write(_filter(_v, rawExpr='$child.description')) # from line 178, col 6.
                write(''' function prototypes
''')
                _v = VFFSL(SL,"result",True) # '$result' on line 179, col 1
                if _v is not None: write(_filter(_v, rawExpr='$result')) # from line 179, col 1.
        write('''
// ********************************************************
// MAIN ROUTINE
// ********************************************************
''')
        _v = VFFSL(SL,"features.Driver.mainRoutine",True) # '$features.Driver.mainRoutine' on line 186, col 1
        if _v is not None: write(_filter(_v, rawExpr='$features.Driver.mainRoutine')) # from line 186, col 1.
        write('''
// ********************************************************
// FUNCTION IMPLEMENTATIONS
// ********************************************************

inline void *xmds_malloc(size_t size)
{
  void *retPointer = _xmds_malloc(size);
  if ( !retPointer )
    _LOG(_ERROR_LOG_LEVEL, "ERROR: Couldn\'t allocate %zu bytes of memory!", size);
  return retPointer;
}

''')
        #  only loop over the elements that implement the prototypes function
        for child in VFFSL(SL,"children",True): # generated from line 201, col 1
            #  Prevent writing zero-length function implementations
            result = VFN(VFFSL(SL,"child",True),"implementationsForFunctionName",False)('functionImplementations')
            if result and not result.isspace(): # generated from line 204, col 3
                write('''
// ********************************************************
//   ''')
                _v = VFFSL(SL,"child.description",True) # '$child.description' on line 207, col 6
                if _v is not None: write(_filter(_v, rawExpr='$child.description')) # from line 207, col 6.
                write(''' function implementations
''')
                _v = VFFSL(SL,"result",True) # '$result' on line 208, col 1
                if _v is not None: write(_filter(_v, rawExpr='$result')) # from line 208, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    name = ''

    id = ''

    _mainCheetahMethod_for_Simulation = 'writeBody'

## END CLASS DEFINITION

if not hasattr(Simulation, '_initCheetahAttributes'):
    templateAPIClass = getattr(Simulation,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(Simulation)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=Simulation()).run()


