#!/usr/bin/env python3




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from Cheetah.compat import unicode
from xpdeint.Vectors._VectorElement import _VectorElement

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '3.3.2'
__CHEETAH_versionTuple__ = (3, 3, 2, 'final', 0)
__CHEETAH_src__ = 'VectorElement.tmpl'
__CHEETAH_srcLastModified__ = 'Mon, 17 Jul 2023 19:11:41 -0300'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class VectorElement(_VectorElement):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(VectorElement, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: vector $name at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''vector ''')
        _v = VFFSL(SL,"name",True) # '$name' on line 29, col 26
        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 29, col 26.
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def defines(self, **KWS):



        ## CHEETAH: generated from @def defines at line 34, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(VectorElement, self).defines()
        if _v is not None: write(_filter(_v))
        # 
        write('''// vector ''')
        _v = VFFSL(SL,"name",True) # '$name' on line 38, col 11
        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 38, col 11.
        write(''' defines
#define _''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 39, col 10
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 39, col 10.
        write('''_ncomponents ''')
        _v = VFFSL(SL,"nComponents",True) # '$nComponents' on line 39, col 28
        if _v is not None: write(_filter(_v, rawExpr='$nComponents')) # from line 39, col 28.
        write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def globals(self, **KWS):



        ## CHEETAH: generated from @def globals at line 46, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = super(VectorElement, self).globals()
        if _v is not None: write(_filter(_v))
        # 
        write('''// vector ''')
        _v = VFFSL(SL,"name",True) # '$name' on line 50, col 11
        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 50, col 11.
        write(''' globals
size_t ''')
        _v = VFFSL(SL,"allocSize",True) # '${allocSize}' on line 51, col 8
        if _v is not None: write(_filter(_v, rawExpr='${allocSize}')) # from line 51, col 8.
        write(''' = 0;
''')
        _v = VFFSL(SL,"type",True) # '$type' on line 52, col 1
        if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 52, col 1.
        write('''* _''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 52, col 9
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 52, col 9.
        write(''' = NULL;
''')
        _v = VFFSL(SL,"type",True) # '$type' on line 53, col 1
        if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 53, col 1.
        write('''* _active_''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 53, col 16
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 53, col 16.
        write(''' = NULL;
''')
        for aliasName in VFFSL(SL,"aliases",True): # generated from line 54, col 3
            _v = VFFSL(SL,"type",True) # '$type' on line 55, col 1
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 55, col 1.
            write('''* ''')
            _v = VFFSL(SL,"aliasName",True) # '${aliasName}' on line 55, col 8
            if _v is not None: write(_filter(_v, rawExpr='${aliasName}')) # from line 55, col 8.
            write(''' = NULL;
''')
        # 
        if VFFSL(SL,"needsTransforms",True): # generated from line 58, col 3
            write('''
ptrdiff_t _''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 60, col 12
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 60, col 12.
            write('''_basis = -1;
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def initialiseFunctionContents(self, function, **KWS):



        ## CHEETAH: generated from @def initialiseFunctionContents($function) at line 68, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"integratingComponents",True): # generated from line 70, col 3
            write("""// Because we're integrating over dimensions, we need to set the vector to zero.
bzero(_active_""")
            _v = VFFSL(SL,"id",True) # '${id}' on line 72, col 15
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 72, col 15.
            write(''', sizeof(''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 72, col 29
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 72, col 29.
            write(''') * ''')
            _v = VFFSL(SL,"allocSize",True) # '${allocSize}' on line 72, col 40
            if _v is not None: write(_filter(_v, rawExpr='${allocSize}')) # from line 72, col 40.
            write(''');
''')
        if VFFSL(SL,"initialiser",True): # generated from line 74, col 3
            write('''
''')
            _v = VFFSL(SL,"initialiser.initialiseVector",True) # '${initialiser.initialiseVector}' on line 76, col 1
            if _v is not None: write(_filter(_v, rawExpr='${initialiser.initialiseVector}')) # from line 76, col 1.
        if VFFSL(SL,"needsTransforms",True): # generated from line 78, col 3
            write('''
_''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 80, col 2
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 80, col 2.
            write('''_basis = ''')
            _v = VFFSL(SL,"basisIndexForBasis",False)(self.initialBasis) # '$basisIndexForBasis(self.initialBasis)' on line 80, col 16
            if _v is not None: write(_filter(_v, rawExpr='$basisIndexForBasis(self.initialBasis)')) # from line 80, col 16.
            write(''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def basisTransformFunctionContents(self, function, **KWS):



        ## CHEETAH: generated from @def basisTransformFunctionContents($function) at line 85, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        featureOrdering = ['TransformMultiplexer']
        dict = {'function': function}
        _v = VFFSL(SL,"insertCodeForFeatures",False)('basisTransformFunctionContentsBegin', featureOrdering, dict) # "${insertCodeForFeatures('basisTransformFunctionContentsBegin', featureOrdering, dict)}" on line 89, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeatures('basisTransformFunctionContentsBegin', featureOrdering, dict)}")) # from line 89, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def initialise(self, **KWS):



        ## CHEETAH: generated from @def initialise at line 96, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        if VFFSL(SL,"needsInitialisation",True): # generated from line 98, col 3
            for aliasName in VFFSL(SL,"aliases",True): # generated from line 99, col 5
                write('''_active_''')
                _v = VFFSL(SL,"id",True) # '${id}' on line 100, col 9
                if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 100, col 9.
                write(''' = ''')
                _v = VFFSL(SL,"aliasName",True) # '$aliasName' on line 100, col 17
                if _v is not None: write(_filter(_v, rawExpr='$aliasName')) # from line 100, col 17.
                write(''';
''')
                _v = VFN(VFFSL(SL,"functions",True)['initialise'],"call",False)() # "${functions['initialise'].call()}" on line 101, col 1
                if _v is not None: write(_filter(_v, rawExpr="${functions['initialise'].call()}")) # from line 101, col 1.
                write('''
''')
            write('''_active_''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 103, col 9
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 103, col 9.
            write(''' = _''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 103, col 18
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 103, col 18.
            write(''';
''')
            _v = VFN(VFFSL(SL,"functions",True)['initialise'],"call",False)() # "${functions['initialise'].call()}" on line 104, col 1
            if _v is not None: write(_filter(_v, rawExpr="${functions['initialise'].call()}")) # from line 104, col 1.
            write('''
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def allocate(self, **KWS):



        ## CHEETAH: generated from @def allocate at line 112, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
_''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 114, col 2
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 114, col 2.
        write(''' = (''')
        _v = VFFSL(SL,"type",True) # '$type' on line 114, col 11
        if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 114, col 11.
        write('''*) xmds_malloc(sizeof(''')
        _v = VFFSL(SL,"type",True) # '${type}' on line 114, col 38
        if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 114, col 38.
        write(''') * MAX(''')
        _v = VFFSL(SL,"allocSize",True) # '${allocSize}' on line 114, col 53
        if _v is not None: write(_filter(_v, rawExpr='${allocSize}')) # from line 114, col 53.
        write(''',1));
_active_''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 115, col 9
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 115, col 9.
        write(''' = _''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 115, col 18
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 115, col 18.
        write(''';
''')
        for aliasName in VFFSL(SL,"aliases",True): # generated from line 116, col 3
            _v = VFFSL(SL,"aliasName",True) # '$aliasName' on line 117, col 1
            if _v is not None: write(_filter(_v, rawExpr='$aliasName')) # from line 117, col 1.
            write(''' = (''')
            _v = VFFSL(SL,"type",True) # '$type' on line 117, col 15
            if _v is not None: write(_filter(_v, rawExpr='$type')) # from line 117, col 15.
            write('''*) xmds_malloc(sizeof(''')
            _v = VFFSL(SL,"type",True) # '${type}' on line 117, col 42
            if _v is not None: write(_filter(_v, rawExpr='${type}')) # from line 117, col 42.
            write(''') * MAX(''')
            _v = VFFSL(SL,"allocSize",True) # '${allocSize}' on line 117, col 57
            if _v is not None: write(_filter(_v, rawExpr='${allocSize}')) # from line 117, col 57.
            write(''',1)); // alias for _''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 117, col 89
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 117, col 89.
            write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def free(self, **KWS):



        ## CHEETAH: generated from @def free at line 121, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
xmds_free(_''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 123, col 12
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 123, col 12.
        write(''');
_active_''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 124, col 9
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 124, col 9.
        write(''' = _''')
        _v = VFFSL(SL,"id",True) # '${id}' on line 124, col 18
        if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 124, col 18.
        write(''' = NULL;
''')
        for aliasName in VFFSL(SL,"aliases",True): # generated from line 125, col 3
            write('''xmds_free(''')
            _v = VFFSL(SL,"aliasName",True) # '$aliasName' on line 126, col 11
            if _v is not None: write(_filter(_v, rawExpr='$aliasName')) # from line 126, col 11.
            write('''); // alias for _''')
            _v = VFFSL(SL,"id",True) # '${id}' on line 126, col 38
            if _v is not None: write(_filter(_v, rawExpr='${id}')) # from line 126, col 38.
            write('''
''')
            _v = VFFSL(SL,"aliasName",True) # '${aliasName}' on line 127, col 1
            if _v is not None: write(_filter(_v, rawExpr='${aliasName}')) # from line 127, col 1.
            write(''' = NULL;
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def findMaximum(self, variableName, basis=None, **KWS):



        ## CHEETAH: generated from @def findMaximum($variableName, $basis = None) at line 131, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''real ''')
        _v = VFFSL(SL,"variableName",True) # '${variableName}' on line 132, col 6
        if _v is not None: write(_filter(_v, rawExpr='${variableName}')) # from line 132, col 6.
        write(''' = 0.0;

''')
        if VFFSL(SL,"type",True) == 'real': # generated from line 134, col 3
            modFunction = 'abs'
        else: # generated from line 136, col 3
            modFunction = 'mod2'
        ## START CAPTURE REGION: _96460494 loopContents at line 139, col 3 in the source.
        _orig_trans_96460494 = trans
        _wasBuffering_96460494 = self._CHEETAH__isBuffering
        self._CHEETAH__isBuffering = True
        trans = _captureCollector_96460494 = DummyTransaction()
        write = _captureCollector_96460494.response().write
        write('''real _current_size = ''')
        _v = VFFSL(SL,"modFunction",True) # '${modFunction}' on line 140, col 22
        if _v is not None: write(_filter(_v, rawExpr='${modFunction}')) # from line 140, col 22.
        write('''(_active_${vector.id}[${index}]);
if (_current_size > ''')
        _v = VFFSL(SL,"variableName",True) # '$variableName' on line 141, col 21
        if _v is not None: write(_filter(_v, rawExpr='$variableName')) # from line 141, col 21.
        write(''') // UNVECTORISABLE
  ''')
        _v = VFFSL(SL,"variableName",True) # '${variableName}' on line 142, col 3
        if _v is not None: write(_filter(_v, rawExpr='${variableName}')) # from line 142, col 3.
        write(''' = _current_size;
''')
        trans = _orig_trans_96460494
        write = trans.response().write
        self._CHEETAH__isBuffering = _wasBuffering_96460494 
        loopContents = _captureCollector_96460494.response().getvalue()
        del _orig_trans_96460494
        del _captureCollector_96460494
        del _wasBuffering_96460494
        _v = VFFSL(SL,"loopOverVectorsWithInnerContentTemplate",False)([self], loopContents, basis = basis) # '${loopOverVectorsWithInnerContentTemplate([self], loopContents, basis = basis)}' on line 144, col 1
        if _v is not None: write(_filter(_v, rawExpr='${loopOverVectorsWithInnerContentTemplate([self], loopContents, basis = basis)}')) # from line 144, col 1.
        if VFFSL(SL,"type",True) == 'complex': # generated from line 145, col 3
            _v = VFFSL(SL,"variableName",True) # '${variableName}' on line 146, col 1
            if _v is not None: write(_filter(_v, rawExpr='${variableName}')) # from line 146, col 1.
            write(''' = sqrt(''')
            _v = VFFSL(SL,"variableName",True) # '${variableName}' on line 146, col 24
            if _v is not None: write(_filter(_v, rawExpr='${variableName}')) # from line 146, col 24.
            write('''); // Take the square root to find the modulus.
''')
        _v = VFFSL(SL,"insertCodeForFeatures",False)('findMax', ['Driver'], {'variable': ''.join(['&',str(VFFSL(SL,"variableName",True))]), 'count': '1'}) # "${insertCodeForFeatures('findMax', ['Driver'], {'variable': c'&${variableName}', 'count': '1'})}" on line 148, col 1
        if _v is not None: write(_filter(_v, rawExpr="${insertCodeForFeatures('findMax', ['Driver'], {'variable': c'&${variableName}', 'count': '1'})}")) # from line 148, col 1.
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        # 
        # VectorElement.tmpl
        # 
        # Created by Graham Dennis on 2007-08-28.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write('''
''')
        # 
        #   Description of template
        write('''
''')
        # 
        #   Defines needed at the start of the simulation
        write('''
''')
        # 
        #   Globals needed at the start of the simulation
        write('''
''')
        # 
        #   Write the vector initialisation routine
        write('''

''')
        # 
        #   Initialise vector (called from segment 0)
        write('''
''')
        # 
        #   Allocate (and initialise active pointers) (called from main)
        write('''

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_VectorElement = 'writeBody'

## END CLASS DEFINITION

if not hasattr(VectorElement, '_initCheetahAttributes'):
    templateAPIClass = getattr(VectorElement,
                               '_CHEETAH_templateClass',
                               Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(VectorElement)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit https://cheetahtemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=VectorElement()).run()


